<?php
include("$LIBPATH/log/logdetail.class.php");

/**
 *
 *                      
 *
 *                                                                                   
 *
 */

class NodeLog
{
//                                                             
 var $E_OK = 0;
var $E_WARN = 1;
var $E_ERR = 2;

var $MSG_OK = "blue";
var $MSG_WARN = "orange";
var $MSG_ERR = "red";

//                                                             
 var $id = 0;
var $magic = 0;
var $user_id = 0;
var $do = 0;
var $timestamp_start = 0;
var $timestamp_end = 0;
var $timestamp_request = 0;
var $logevent_id = 0;
var $module = "";
var $obj_type = 0;
var $obj_command= "";

var $logdetail = array();
var $logevent = array();
var $children = array();

/**
  *                 
  *
  *        
  **/
function NodeLog($logevent_id = 0)
{
global $MAGIC, $USER_ID, $DO, $MODULE, $time;

$this->magic = (int) $MAGIC;
$this->user_id = (int) $USER_ID;
$this->do = (int) $DO;
$this->logevent_id = $logevent_id;
$this->module = $MODULE;

$this->timestamp_start = time();
$this->timestamp_request = $time;
}

function initFromId($id) {
$sql = "SELECT timestamp_start, timestamp_end, timestamp_request, user_id, do, logevent_id, status, magic, module, obj_type, obj_command
				FROM logevent
				WHERE id = ".sqlf_tl_num($id);
$rs = query($sql);//            

if ($rs["num"]) {

$row = $rs["arr"][0];

//                
 $this->id = $id;
$this->logevent_id = $row["logevent_id"];
$this->timestamp_start = $row["timestamp_start"];
$this->timestamp_end = $row["timestamp_end"];
$this->timestamp_request = $row["timestamp_request"];
$this->user_id = $row["user_id"];
$this->do = $row["do"];
$this->magic = $row["magic"];
$this->status = $row["status"];
$this->module = $row["module"];
$this->obj_type = $row["obj_type"];
$this->obj_command = $row["obj_command"];

//            

$sql = "SELECT name, value_text, value_int, obj_type, obj_id
					FROM loginfo
					WHERE logevent_id = ".sqlf_tl_num($id);
$rs = query($sql);//            

for ($i = 0; $i < $rs["num"]; $i++) {
$row = $rs["arr"][$i];
$tmp = new LogDetail();

$tmp->setName($row["name"]);
$tmp->setText($row["value_text"]);
$tmp->setInt($row["int"]);
$tmp->setObj($row["obj_type"],$row["obj_id"]);

$this->addDetail($tmp);
}

return true;
} else {
return false;
}
}

function cmdlogevent()
{

$sql = "INSERT INTO logevent
                (timestamp_start, timestamp_end, timestamp_request, user_id, do, logevent_id, status, magic, module, obj_type, obj_command) VALUES
                (".sqlf_tl_num($this->timestamp_start).", ".sqlf_tl_num($this->timestamp_end).", ".sqlf_tl_num($this->timestamp_request).", ".sqlf_tl_num($this->user_id).", ".sqlf_tl_num($this->do).", 
					".sqlf_tl_num($this->logevent_id).", ".sqlf_tl_num($this->status).", ".sqlf_tl_num($this->magic).", '".sqlslashes($this->module)."', 
					".sqlf_tl_num($this->obj_type).", '".sqlslashes($this->obj_command)."')";
$rs = query($sql);//            

return $rs["iid"];
}

/**
  *             
  *
  *        
  **/
function log($obj_type, $obj_command, $status)
{ 
//            
 $this->obj_type = (int) $obj_type;
$this->obj_command = $obj_command;
$this->status = (int) $status;

//               
 $this->timestamp_end = time();

if ($this->debug) echo "userid: <b>$this->user_id</b> requested to log <b>$info</b> during do: <b>$this->do</b> [$this->magic]<br>";

//        
 $this->id = $this->cmdLogEvent();

reset($this->logdetail);

foreach ($this->logdetail as $ld) {
$ld->log($this->id);
}

//                                             
 $this->logdetail = array();
}

function cmdlog()
{
//                                     
 }

function cmderror()
{
//                                       
 }

function addDetail($detail_obj)
{
//                   
 $this->logdetail[] = $detail_obj;

//              
 return sizeof($this->logdetail);

}

function addEvent($event_obj) {
//                  
 $this->logevent[$event_obj->id] = $event_obj;

//              
 return sizeof($this->logevent);
}

function isParent() {
$sql = "SELECT id
				FROM logevent
				WHERE logevent_id = ".sqlf_tl_num($this->id);
$rs = query($sql);//            

if ($rs["num"]) {
for ($i = 0; $i < $rs["num"]; $i++) {
$this->children[] = $rs["arr"][$i]["id"];
}

return $rs["num"];
} else {
return false;
}

}

function getString() {
if ($this->status == $this->E_OK) $mark = $this->MSG_OK;
elseif ($this->status == $this->E_WARN) $mark = $this->MSG_WARN;
else $mark = $this->MSG_ERR;

$out = "<br><b><font color=$mark>[$this->obj_command($this->obj_type)]</font></b><br>";

for ($i = 0; $i < sizeof($this->logdetail); $i++) {
$detail = $this->logdetail[$i];
$out .= "<font color=$mark>$detail->name</font> - $detail->value_text ($detail->value_int); $detail->obj_id ($this->obj_type)<br>";
}

if ($this->isParent()) {
reset($this->logevent);

foreach($this->logevent as $logevent) {
$out .= $logevent->getString();
}
}

return $out;
}

function getArray() {
if ($this->status == $this->E_OK) $mark = $this->MSG_OK;
elseif ($this->status == $this->E_WARN) $mark = $this->MSG_WARN;
else $mark = $this->MSG_ERR;

$out = array();
$tmp = array();

$tmp["obj_command"] = $this->obj_command;
$tmp["obj_type"] = $this->obj_type;
$tmp["timestamp_request"] = $this->timestamp_request;
$tmp["timestamp_start"] = $this->timestamp_start;
$tmp["timestamp_end"] = $this->timestamp_end;
$tmp["user_id"] = $this->user_id;
$tmp["magic"] = $this->magic;
$tmp["color"] = $mark;

for ($i = 0; $i < sizeof($this->logdetail); $i++) {
$detail = $this->logdetail[$i];

$line = $tmp;
$line["d_name"] = $detail->name;
$line["d_value_text"] = $detail->value_text;
$line["d_value_int"] = $detail->value_int;
$line["d_obj_id"] = $detail->obj_id;
$line["d_obj_type"] = $detail->obj_type;

$out[] = $line;
}

if ($this->isParent()) {
reset($this->logevent);

foreach($this->logevent as $logevent) {
$out = array_merge($out,$logevent->getArray());
}
}

return $out;
}
}

?>
