<?php

/**
 * 
 *
 *                                                                               
 *                 
 **/
class DetailComponent extends ListComponent
{
function DetailComponent( $textHidden, $textShown, &$component )
{
parent::ListComponent();
$this->d_values["textHidden"] = $textHidden;
$this->d_values["textShown"] = $textShown;
$this->d_values["showDetails"] = FALSE;
$this->setComponent( "c", $component );
}

function setShowDetails( $doShow )
{
$this->d_values["showDetails"] = $doShow;
}

function setImage( $image ) {
$this->d_values['img'] = $image;
}

function _getDivHtml($flapped, $onclick) {
global $ICO_DETAIL_COLLAPSED, $ICO_DETAIL_EXPANDED;

if ($flapped) {
$image = "<img src=\"$ICO_DETAIL_EXPANDED\" onclick=\"$onclick\" style=\"cursor:pointer;\">";
$html = $this->_getDivRow($image, "textShown");
} else {
$image = "<img src=\"$ICO_DETAIL_COLLAPSED\" onclick=\"$onclick\" style=\"cursor:pointer;\">";
$html = $this->_getDivRow($image, "textHidden");
}
return $html;
}

function _getDivRow($image, $txt) {
$ico_null = img("");
$bgcolor = "#CECECE";
$height = 10;
$img = $this->d_values['img'];
if( $img ) $img = img( $img );
if (true) {
$htmlLeft = "<table width=100% border=0 cellspacing=0 cellpadding=0>
			  <tr><td width=97% height=$height></td>
			      <td rowspan=3 align=right><nowrap>&nbsp;".str_replace(" ","&nbsp;",$this->d_values[$txt])."</nowrap></td></tr>
			  <tr><td height=1 bgcolor=$bgcolor>$ico_null</td></tr>
			  <tr><td height=$height></td></tr></table>";
$htmlRight = "<table width=100% border=0 cellspacing=0 cellpadding=0>
			  <tr><td rowspan=3>$img&nbsp;</td><td rowspan=3>$image&nbsp;</td><td width=97% height=$height></td>
			  <tr><td height=1 bgcolor=$bgcolor>$ico_null</td></tr>
			  <tr><td height=$height></td></tr></table>";
$html = array($htmlLeft, $htmlRight);
} else {
$html =	"<table width=100% border=0>\n";
$html .= "<tr><td width=49%><hr></td><td>$image</td><td><nbsp>$img".
$this->d_values[$txt]."</nbsp></td><td width=49%><hr></td></tr>\n";
$html .= "</table>\n";
}
return $html;
}

function getHTML( &$form, $prefix, $doCheck, $checkSeverity, $key )
{
if ( $doCheck && $this->isError() )
$this->d_values["showDetails"] = TRUE;

$html = array();

$onclick = $form->getJsActionCall( new ValueSetterFormAction( $key, "showDetails",
!$this->d_values["showDetails"] ) );

if ( $this->d_values["showDetails"] ) 
{
$html[] = $this->_getDivHtml(true, $onclick);

$html = $this->mergeResult( $html, parent::getHTML($form, $prefix, $doCheck, $checkSeverity, $key ) );
}
else
{
$html[] = $this->_getDivHtml(false, $onclick);
}
return $html;
}
}

?>
