<?
/**
 *           
 *                                        
 *                                                                                               
 *                      
 *                                                                       
 */


/**
 *
 *                                                 
 *
 *
 */
function translate_pagetag( $page_id, $tagname, $type = T_PAGECONTENT )
{
$tags = array();
switch ( $type )
{
case T_PAGECONTENT:
//                         

//           
 $sql = "SELECT id FROM objtag WHERE obj_type=10007 AND obj_id=".sqlf_tl_num($page_id)." WHERE name='".sqlf_escaped($tagname)."'";
$rs = query( $sql );//            
 if ( $rs["num"] != 0 )
{
$tags = obj_tranlate( $rs["arr"][0]["id"], "objtag", $page_id, "page" );
}
break;
default:
halt( 7, "translate_pagetag: not implemented: type($type)" );
}
return $tags;
}

function translate_pagecontent($page_id, $edit = false, $depth = 0, $node_id = 0, $sumdebug = false) {
global $FEATURE, $TEMPLATETAG_VISITED, $CONTENTTAG_VISITED, $TS, $DEBUG;

$debugtime = $DEBUG["time"];

$page = get_pageinfo($page_id);
if (!$page["id"]) return Array();

$folder = get_folderinfo($page["folder_id"]);
$node_id = $node_id?$node_id:$folder["node_id"];

if ($debugtime) $t1 = microtime();

//             
 $ttags = obj_translate($page["template_id"],"template_nopub",$page_id,"page",$node_id,false,$depth);
if ($debugtime) $t2 = microtime();
if (!$FEATURE["reset_visited_tags"]) { $TEMPLATETAG_VISITED = Array(); $CONTENTTAG_VISITED = Array(); }
//            
 $ptags = obj_translate($page["content_id"],"content",$page_id,"page",$node_id,$edit,$depth);
if ($debugtime) $t3 = microtime();
if (!$FEATURE["reset_visited_tags"]) { $TEMPLATETAG_VISITED = Array(); $CONTENTTAG_VISITED = Array(); }
$tmp["id"] = $page["folder_id"];
$tmp["type"] = T_FOLDER;
//                         
 $foldertags = obj_translate($tmp,"obj",$page_id,"page",$node_id,false,$depth);
if (!$FEATURE["reset_visited_tags"]) { $TEMPLATETAG_VISITED = Array(); $CONTENTTAG_VISITED = Array(); }

if ($debugtime) $t4 = microtime();
if ($FEATURE['template_objprop']) {
$tmp["id"] = $page["template_id"];
$tmp["type"] = T_TEMPLATE;
//                           
 $templatetags = obj_translate($tmp,"obj",$PAGE_ID,"page",$node_id);
}

if ($debugtime) $t5 = microtime();
$tmp["id"] = $page_id;
$tmp["type"] = T_PAGE;
//                       
 $pagetags = obj_translate($tmp,"obj",$page_id,"page",$node_id,false,$depth);

if ($debugtime) $t6 = microtime();
if (!$pagetags) $pagetags = array();
if (!$templatetags) $templatetags = array();
if (!$foldertags) $foldertags = array();
if (!$ttags) $ttags = array();
if (!$ptags) $ptags = array();

if ($debugtime) {
$TS["translate_pagecontent_tpl"] = calctime($t1,$t2,12);
$TS["translate_pagecontent_content"] = calctime($t2,$t3,12);
$TS["translate_pagecontent_ofolder"] = calctime($t3,$t4,12);
$TS["translate_pagecontent_otpl"] = calctime($t4,$t5,12);
$TS["translate_pagecontent_opage"] = calctime($t5,$t6,12);
if ($sumdebug) {
$TS["sum_translate_pagecontent_tpl"] += $TS["translate_pagecontent_tpl"];
$TS["sum_translate_pagecontent_tpl_invocations"] += 1;
$TS["sum_translate_pagecontent_content"] += $TS["translate_pagecontent_content"];
$TS["sum_translate_pagecontent_ofolder"] += $TS["translate_pagecontent_ofolder"];
$TS["sum_translate_pagecontent_otpl"] += $TS["translate_pagecontent_otpl"];
$TS["sum_translate_pagecontent_opage"] += $TS["translate_pagecontent_opage"];
}
}

return $ttags + $ptags + $pagetags + $templatetags + $foldertags;

}

function optimize_datasource_result( $rs, $max_obj, $mother_id, $contentgroup_id, $node_id )
{
$cgs = get_contentgroups($node_id);

global $FEATURE;
$start = microtime();
$contentset_cache = array();

$sort = array();

foreach ( $rs["arr"] as $v )
{
$v["pos"] = $i++;
if ( $v["contentset_id"] != 0 )
{
if ( !isset( $contentset_cache[$v["contentset_id"]] ) )
$sort[] = $v["contentset_id"];
$contentset_cache[$v["contentset_id"]][$v["contentgroup_id"]] = $v;
}
else if ( $FEATURE["ds_empty_cs"] )
$sort[] = $v;
}
if ( $max_obj > 0 )
$sort = array_slice($sort, 0, $max_obj);

$return = array();
foreach ( $sort as $pageSet )
{
if ( is_array($pageSet) )
{
//                  
 $return[$pageSet["pos"]] = $pageSet;
}
else
{
$set = $contentset_cache[$pageSet];
if ( isset( $set[$contentgroup_id] ) )
$return[$set[$contentgroup_id]["pos"]] = $set[$contentgroup_id];
else
{
foreach ( $cgs as $cgid=>$cg )
{
if ( isset( $set[$cgid] ) )
{
$return[$set[$cgid]["pos"]] = $set[$cgid];
break;
}
}
}
}
}
ksort($return);
$end = microtime();
decho( "DS: optimize-time: ".calctime($start, $end, 5)."<br>", "ds" );
$ret["num"] = count( $sort );
$ret["arr"] = $return;
return $ret;
}

function is_superedit_type( $type )
{
//              /                                        /                                             
 if ($type == 1 || $type == 2 || $type == 3 ||$type == 10 || $type == 27 || $type == 9 )
return true;

return false;
}


//                                                                     
//                                                                                     
function obj_translate($o_id,$o_type,$mother_id = 0,$mother_type = "",
$node_id = 0, $edit = false, $depth = 0, $magic_keyword="",
$magic_value="") {


if ( !is_array( $magic_keyword ) && $magic_keyword ) $magic_keyword = array( $magic_keyword );
//                                      
 if ($depth > 1) return Array();
//                                
 if (!$o_id || !$o_type) {
//                                       
 //                                                                                    
 return Array();
}

//                                                                                                                                                  

global $CONSTRUCT_PARTS, $CACHE_OBJ_TRANSLATE, $TS, $DEBUG, $CACHE_MAX_ENTRIES, $TAG_PREFIX, $FEATURE, $PUBWAY, $T_PAGECONTENT, $T_TEMPLATE, $SID, $SESSION_TOKEN, $INPAGEEDIT_TAGS, $CONSTRUCTS, $CONSTRUCT_PARTS, $CONTENTGROUPS, $T_TEMPLATETAG, $T_CONTENTTAG, $T_OBJTAG, $NODE_ID, $T_IMAGE, $T_FILE;

if ( !$node_id ) $node_id = $NODE_ID;

$_ottime = $DEBUG["time_objtranslate"];
$_ottime1 = $DEBUG["time_objtranslate_detail"];

if (!$_ottime) $_ottime1 = false;

if ($_ottime) $_t1 = microtime();

if ($FEATURE["objtranslatecache"] && !$DEBUG["skip_objtranslatecache"]) {
$cachekey["o_id"] = is_array($o_id)?implode("-",$o_id):$o_id;
$cachekey["o_type"] = $o_type;
$cachekey["mother_id"] = $mother_id;
$cachekey["mother_type"] = $mother_type;
$cachekey["node_id"] = $node_id;
$cachekey["depth"] = $depth;
$cachekey["PUBWAY"] = $PUBWAY;
$cachekey = serialize($cachekey);
if ($o_type == "content") {
$cachetype = $T_PAGECONTENT;
$cacheid = $o_id;
}
if ($o_type == "template"  || $o_type == "template_nopub") {
$cachetype = $T_TEMPLATE;
$cacheid = $o_id;
}
if ($o_type == "obj" ) {
//                                               
 $cachetype = $o_id["type"];
$cacheid = $o_id["id"];
}
if (!$edit) {
$sql = "SELECT value_tags FROM objtranslatecache WHERE cachekey = '".sqlslashes($cachekey)."'";
$rs = query($sql,1);//            
 if ($rs["num"] > 0) {
$tags = unserialize($rs["arr"][0]["value_tags"]);
if (!is_array($tags)) $tags = Array();
if ($PUBWAY == "dyn" || $PUBWAY == "real") {
while (list($key,$val) = each($tags)) {
$tags[$key] = str_replace("OBJTRANSLATECACHESID",$SESSION_TOKEN,$val);
}
}
return $tags;
}
} else {
$sql = "DELETE FROM objtranslatecache WHERE cachekey = '".sqlslashes($cachekey)."'";
query($sql);//            
 //                                                                           
 }
}

//                        
 if ($mother_type == 'page' && $mother_id) {
$sql_page = "SELECT ml_id from template, page
		WHERE template.id = page.template_id and page.id = ".sqlf_tl_num($mother_id);
$rs_page = query($sql_page);//            
 $ml_id = $rs_page["arr"]["0"]["ml_id"];
}

//    
 if ($o_type == "globaltag" || $o_type == "contenttag" || $o_type == "templatetag" || $o_type == "objtag") {
$tagtable = $o_type;
if ($o_type == "globaltag") $sqlpart = "global";
if ($o_type == "contenttag") $sqlpart = "content";
if ($o_type == "templatetag") $sqlpart = "template";
if ($o_type == "objtag") $sqlpart = "obj";
$tagtype = $sqlpart;
$sql = "SELECT ".sqlf_tl_num($o_id)." AS id, value.id as value_id, part.id AS pid, part.type_id, part.ml_id, part.keyword, part.info_int, part.info_text, part.hidden, ".sqlf_table($o_type).".construct_id AS cid, part.partorder, ".sqlf_table($o_type).".name, value.info, value.value_text, value.value_ref, ".sqlf_table($o_type).".enabled, 1 AS pub
		FROM ".sqlf_table($o_type)."
		LEFT JOIN value ON (".sqlf_table($o_type).".id = value.".sqlf_name($o_type)."_id)
		LEFT JOIN part ON (value.part_id = part.id)
		WHERE ".sqlf_table($o_type).".id = ".sqlf_tl_num($o_id);
}

//    
 if ($o_type == "obj") {
$tagtable = "objtag";
$tagtype = "obj";

$otype_match = " = " . sqlf_tl_num($o_id["type"]);
//                                                                                      
 //                                                                                     
 //                                                                                      
 //                           
 if ($o_id["type"] == $T_FILE) {
$otype_match = " IN (".sqlf_tl_num($T_IMAGE).", ".sqlf_tl_num($T_FILE).")";
}

if (!is_array($o_id) || !$o_id["id"] || !$o_id["type"]) halt(7,"obj_translate: invalid objtag o_id($o_id) o_id[id](".$o_id["id"].") o_id[type](".$o_id["type"].")");
$sql = "SELECT objtag.id, part.id AS pid, part.type_id, part.ml_id, part.keyword, part.info_int, part.info_text, part.hidden, objtag.construct_id AS cid, part.partorder, objtag.name, value.info, value.value_text, value.value_ref, objtag.enabled, 0 AS pub
		FROM objtag
		LEFT JOIN value ON (objtag.id = value.objtag_id)
		LEFT JOIN part ON (value.part_id = part.id)
		WHERE objtag.obj_id = ".sqlf_tl_num($o_id["id"])." AND objtag.obj_type $otype_match";
}

//     
 if ($o_type == "content") {
$tagtable = "contenttag";
$tagtype = "content";
$sql = "SELECT value.id as value_id, contenttag.id, part.id AS pid, part.type_id, part.ml_id, part.keyword, part.info_int, part.info_text, part.hidden, contenttag.construct_id AS cid, part.partorder, contenttag.name, value.info, value.value_text, value.value_ref, contenttag.enabled, 1 AS pub
		FROM contenttag
		LEFT JOIN value ON (contenttag.id = value.contenttag_id)
		LEFT JOIN part ON (value.part_id = part.id)
		WHERE contenttag.content_id = ".sqlf_tl_num($o_id);
if ($FEATURE["page_cleanup_36"]) {
$sql .= " AND contenttag.unused = 0";
$sqlunused = "SELECT id, name, '".sqlf_escaped($tagtype)."' AS tagtype, 1 as unused FROM contenttag WHERE content_id = ".sqlf_tl_num($o_id)." AND unused = 1";
}
}

//         
 if ($o_type == "template_nopub") $sqlpart = " AND templatetag.pub = 0";
if ($o_type == "template" || $o_type == "template_nopub") {
$tagtable = "templatetag";
$tagtype = "template";
$sql = "SELECT templatetag.id, part.id AS pid, part.type_id, part.ml_id, part.keyword, part.info_int, part.info_text, part.hidden, templatetag.construct_id AS cid, part.partorder, templatetag.name, value.info, value.value_text, value.value_ref, templatetag.enabled, templatetag.pub
		FROM templatetag
		LEFT JOIN value ON (templatetag.id = value.templatetag_id)
		LEFT JOIN part ON (value.part_id = part.id)
		WHERE templatetag.template_id = ".sqlf_tl_num($o_id)."".$sqlpart;
}

if ($tagtype == "template") $tag_otype = $T_TEMPLATETAG;
if ($tagtype == "content") $tag_otype = $T_CONTENTTAG;
if ($tagtype == "obj") $tag_otype = $T_OBJTAG;

if ($_ottime1) $_t3 = microtime();

//                                               
 //                       //                                  //                  
 $rs = query($sql,false,0,0,MYSQL_ASSOC);//            
 if ($_ottime1) {
$_t2 = microtime();
$TS["ot_partsql"] += calctime($_t3,$_t2,12);
}

load_contentgroups();
load_constructs();
get_contentgroups($node_id);

$inline_id = is_array( $o_id ) ? $o_id["id"] : $o_id;
$inline_editable = get_inline_editable_parts( );

if ($_ottime1) $_t2 = microtime();


$tags = Array();
//                                     
 if (is_array($rs["arr"]))
while (list($key, $val) = each($rs["arr"])) {
if ($FEATURE["inheritable_objtags"] && $o_type == "obj") {
$_pos = strpos($val["name"],".");
if (!$_pos) halt(7,"invalid objtagname(".$val["name"].") and pos($_pos)");
$val["origName"] = $val["name"];
$val["name"] = substr($val["name"],$_pos+1);
$rs["arr"][$key] = $val;
}

$tag_id = $val["id"];
$cid = $val["cid"];
$partorder = $val["partorder"];
//                                                                                                     
 if (!$tags[$tag_id]) {
$tmp = $val;
//                                      
 $mytag = $CONSTRUCT_PARTS[$cid];
//                                            
 
//                                             
 if (is_array($mytag))
while (list($k,$v) = each($mytag)) {
//                          
 //                                  
 //                 
 // 
 //                                    
 //                     
 //                   
 //                               
 $mytag[$k] = $v + $tmp;
}
//         
 } else {
$mytag = $tags[$tag_id];
}

//                      
 if (!is_null($val["value_text"])) $mytag[$partorder] = $val;
else $mytag[0] = $val;

//               
 $tags[$tag_id] = $mytag;

}

if ($_ottime1) {
$_t3 = microtime();
$TS["ot_nonstaticwalk"] += calctime($_t2,$_t3,12);
$_t2 = microtime();
}

$parts = Array();

//                                                          
 if (is_array($tags)) {
reset($tags);
while (list($key,$val) = each($tags)) {
if (!is_null($val)) {
ksort($val);
//                                                      
 //                                  
 reset($val);
while (list($k,$v) = each($val)) {
$parts[] = $v;
}
}
}
reset($parts);
unset($tags);
$tags = Array();
}

if ($_ottime1) {
$_t3 = microtime();
$TS["ot_transsort"] += calctime($_t2,$_t3,12);
}

global $PATH_PAGE, $PATH_FILE, $T_PAGE, $T_FOLDER, $T_FILE, $T_IMAGE;

//                                                                
 $parts[] = "";
$last_id = 0;
$tag = "";
$enabled = 1;
$reset_value = FALSE;

//                                      
 foreach ( $parts as $partv ) {
$partsnew[] = $partv;
if ( $partv["origName"]	)
{
$x = $partv;
$x["name"] = $x["origName"];
unset( $x["origName"] );
$partsnew[] = $x;
}
}
$parts = $partsnew;
//         

//                         
 if ($sqlunused) {
$_rs = query($sqlunused);//            
 foreach ($_rs["arr"] as $v) {
$tags[$v["name"]] = $v;
}
}

$liveeditor = new LiveEditParser();

while (list($k,$partv) = each($parts)) {
$ds = false;
$tag_id = $partv["id"];
$name = $partv["name"];
if ($last_id != $tag_id) {

//                                       
 $part_prop["unique_tag_id"] = $last_id."-".$tag_otype;


$enabled = $partv["enabled"];
if (is_array($part_prop)) {

//                               
 if ($FEATURE["partprop_in_partprop"]) {
if ($_ottime1) $_t5 = microtime();

reset($part_prop);
$part_prop2 = $part_prop;
//                                                                    
 while (list($prop,$v) = each($part_prop)) {
reset($part_prop2);
while (list($key,$val) = each($part_prop2)) {
$part_prop[$prop] = str_replace("<$TAG_PREFIX ".$key.">",$val, $part_prop[$prop]);
}
}

if ($_ottime1) {
$_t4 = microtime();
$TS["ot_strrep1"] += calctime($_t5,$_t4,12);
}

}
//                           
 
reset($part_prop);

if ($_ottime1) $_t4 = microtime();

//                                                               
 //                                            
 while (list($prop,$v) = each($part_prop)) {
//                 
 if ((substr($last_name, strlen($last_name) - 6) == ".style" || 
substr($prop,0,6) == "table."  || substr($prop,0,7) == "table+.") && $v != "") {
if (($_pos = strpos($prop, ".")) === false) continue;
$_type = substr($prop, 0, $_pos);						
$_key = substr($prop, $_pos + 1);
if (strpos($_key, ".")) continue;
if ($_type == "table+") {
$v = "<$_key>$v</$_key>";
} else {
$v = " $_key=\"$v\"";
}
}
$tags[$last_name.".".$prop]["value"] = $v;
$tags[$last_name.".".$prop]["auto"] = true;
if (isset($tags[$last_name]["value"])) $tags[$last_name]["value"] = str_replace("<$TAG_PREFIX ".$prop.">",$v, $tags[$last_name]["value"]);
$valKeep = str_replace("<$TAG_PREFIX ".$prop.">",$v, $valKeep);
}

if ($_ottime1) {
$_t5 = microtime();
$TS["ot_strrep2"] += calctime($_t4,$_t5,12);
}
}

//                                        
 if (isSupereditEnabled(T_PAGE) && $has_inpage_tags && $edit) {
construct_load();
//                                                                                                
 //                                                                                
 $superTag = "<div contenteditable=false id=t_".$last_name." class=\"lock\" ";
if ( $has_inpage_editable_tags ) {
$superTag .= "ondblclick=\"cn3_edit('$last_name','');\" onclick=\"hide_context_menus(); return true;\" oncontextmenu=\"return displayMenu(this, false, event);\" ";
}
$superTag .= ">";
//                               /      
 
//                                       
 $tags[$last_name]["inpage_prefix"] = $superTag;
$tags[$last_name]["inpage_postfix"] = "</div>";
//                                                            
 if ( $has_inpage_editable_tags || $is_cool_set )
{
$tags["$last_name:escape"]["value"] = addslashes($valKeep);
$tags[$last_name]["value"] = $valKeep;
}
unset( $valKeep );
unset($has_inpage_editable_tags);
unset($has_non_inpage_editable_tags);
unset($has_inpage_tags);
}

$str_do_reset = ($reset_value?"TRUE":"FALSE");
decho( "$str_do_reset: resetting value for tag($last_name)<br>", "obj_translate" );
if ( $reset_value ) unset($tags[$last_name]["value"]);
unset($part_prop);
$last_name = $name;
$reset_value = FALSE;
$firstpart = true;
} else $firstpart = false;


if (!$tag_id) break;

if ($_ottime1) $_t4 = microtime();

$last_id = $tag_id;
$partorder = $partv["partorder"];
$cid = $partv["cid"];
$pid = $partv["pid"];
$pub = $partv["pub"];
if ($edit && $cid) {
$sql = "SELECT icon FROM construct WHERE id = ".sqlf_tl_num($cid);
$rs = query($sql,true);//            
 $icon = tag_icon($rs["arr"][0]["icon"]);
}
$val_ref = $partv["value_ref"];
$val_text = $partv["value_text"];
$val_id = $partv['value_id'];
$val = "";
$info = $partv["info"];
$type = $partv["type_id"];
//              
 $auto = !$edit;
$keyword = $partv["keyword"];
$info_int = $partv["info_int"];
$info_text = $partv["info_text"];
if ($_ottime) {
$_t2 = microtime();
if ($_ottime1) $TS["ot_tagicon"] += calctime($_t4,$_t2,12);
$TS["ot"] += calctime($_t1,$_t2,12);
$TS["ot_parttranslate"]++;
}

if (  $FEATURE["magic_part_value"] && $magic_keyword && $edit && in_array($keyword, $magic_keyword))
{
//                      
 $val_text = $magic_value;
$vu_sql = "UPDATE value SET value_text = '" . sqlslashes($magic_value) . "' WHERE id = ".sqlf_tl_num($val_id);
query( $vu_sql );//            
 if ( $enabled == 3 ) {
$vu_sql = "UPDATE ".sqlf_table($tagtable)." SET enabled=1 WHERE id=".sqlf_tl_num($tag_id);
query( $vu_sql );//            
 }
$enabled=1;
$reset_value = FALSE;
//                                        
 unset( $magic_keyword );
}

$part = part_translate($type,$val_text,$val_ref,$info,$keyword,$info_int, $info_text, $tagtable,$tag_id,$enabled,$part_prop,$pid,$name,$o_type,$mother_id,$mother_type,$depth, $edit, $cid, $node_id, $partorder, $tagtype);

//                                                                                  
 if ( isSupereditEnabled(T_PAGE) && !$FEATURE["nofindtagerror"] )
$part_errors = find_tag_error( $part["val"] );
else
$part_errors = array();
if ( count( $part_errors ) > 0 )
{
$part_syntax_error = TRUE;
}
else
{
$part_syntax_error = FALSE;
}
$parteditable = is_superedit_type($type) && $inline_editable[$cid][$partorder];
//                                                                                     
 if (isSupereditEnabled(T_PAGE) && $edit && $parteditable && !$part_syntax_error ) {
if ($part["val"] == "") $tmptag = "&nbsp;&nbsp;";
else {
$tmptag = $liveeditor->prepareIECode($part["val"]);
}
//                                                                                       
 //                                                
 //                                                                                             
 //                      
 $pKeyHandling = "onpaste=\"if (window.event){window.event.returnValue=false;}\" ".
"onbeforepaste=\"DivOnBeforePaste(this);\" ".
"onkeyup=\"return DivHandleKey(this,event)\" ".
"onkeypress=\"return !isDivHandledKey(event);\" ".
"onkeydown=\"return !isDivHandledKey(event);\"";
$part["val"] = "<div class=\"lock\" $pKeyHandling contenteditable=false ".
"id=\"p_".$name."_".$partorder."\" onclick=\"hide_context_menus(); return true;\" ".
"ondblclick=\"cn3_edit('$name','$partorder');\" ".
"oncontextmenu=\"return displayMenu(this, true, event);\">".$tmptag.
"</div>";
$part["part_prop"][$keyword] = $part["val"];
$has_inpage_tags = true;
$has_inpage_editable_tags = true;
$INPAGEEDIT_TAGS[$name][$partorder] = true;
$INPAGEEDIT_TAGS[$name]['construct_id'] = $partv['cid'];
} else if (isSupereditEnabled(T_PAGE) && $edit ) {
$has_inpage_tags = true;
$has_non_inpage_editable_tags = true;
//                                           
 }


if ($_ottime) $_t1 = microtime();


$mlVisible = !$partv["hidden"] && (!$FEATURE['constr_ml_dep'] || (!$partv["ml_id"] || $partv["ml_id"] == "$ml_id"));
$part_prop = $part["part_prop"];

if ( $mlVisible )
{
$val = $part["val"];
$valKeep .= $val; //                                                       
 }

if ($type == 13) $ds = true;

//                                                                                                                                                             
 //                                                                                                            
 if (($enabled == 0) && !$edit) {
//                           
 unset($tags[$name]);
unset($part_prop);
$reset_value = TRUE;
//          
 //                          
 } else {
//                                                                                      
 if (($enabled == 3 && !$INPAGEEDIT_TAGS[$name][$partorder]) || $enabled == 2 || $enabled == 0) $reset_value = TRUE;
$tags[$name]["value"] .= $val;
$tags[$name]["id"] = $tag_id;
$tags[$name]["cid"] = $cid;
$tags[$name]["pub"] = $pub;
$tags[$name]["icon"] = $icon;
$tags[$name]["auto"] = $auto;
$tags[$name]["ds"] = $ds;
$tags[$name]["tagtype"] = $tagtype;
if ( $part_syntax_error )
{
$tags[$name]["err"][$partorder]["partorder"] = $partorder;
$tags[$name]["err"][$partorder]["partid"] = $pid;
$tags[$name]["err"][$partorder]["inpageeditable"] = $parteditable;
$tags[$name]["err"][$partorder]["err"] = $part_errors;
}
$tags[$name]["inpageeditable"] |= $INPAGEEDIT_TAGS[$name][$partorder]?TRUE:FALSE;
$tags["$name:escape"]["auto"] = true;
$tags["$name:escape"]["value"] .= addslashes($val);

global $CN_TRIMMED_TAGS;
if ($CN_TRIMMED_TAGS[$name]) {
$tags["$name:trimmed"]["auto"] = true;

$tmp = strip_tags($val);
$origlen = strlen($tmp);
$tmp = substr($tmp,0,$CN_TRIMMED_TAGS[$name]);

if ($origlen > $CN_TRIMMED_TAGS[$name]) {
$lastwordend = strrpos($tmp," ");
if (is_int($lastwordend)) $tmp = substr($tmp,0,$lastwordend);
}

$tags["$name:trimmed"]["value"] = $tmp;
}

}

$tags["$name.visible"]["value"] = $enabled;
$tags["$name.empty"]["value"] = (strlen($tags[$name]["value"]) > 0)?0:1; 
}


//                          
 if ($o_type == "obj" && $o_id["type"] == $T_FOLDER) {
$folder = get_folderinfo($o_id["id"]);
$tags["ordner.id"]["auto"] = true;
$tags["ordner.id"]["value"] = $o_id["id"];
$tags["ordner.name"]["auto"] = true;
$tags["ordner.name"]["value"] = $folder["name"];
$tags["ordnername"] = $tags["ordner.name"];
$tags["ordner.beschreibung"]["auto"] = true;
$tags["ordner.beschreibung"]["value"] = $folder["description"];
$tags["ordnerbeschreibung"] = $tags["ordner.beschreibung"];
$tags["ordner.mother"]["auto"] = true;
$tags["ordner.mother"]["value"] = $folder["mother"];
$tags["ordner.pub_dir"]["auto"] = true;
$tags["ordner.pub_dir"]["value"] = $folder["pub_dir"];
$node = get_nodeinfo($folder["node_id"]);
$tags["node.id"]["auto"] = true;
$tags["node.id"]["value"] = $node["id"];
$tags["node.host"]["auto"] = true;
$tags["node.host"]["value"] = $node["host"];
$tags["node.pub_dir"]["auto"] = true;
$tags["node.pub_dir"]["value"] = $node["pub_dir"];
$tags["node.utf8"]["auto"] = true;
$tags["node.utf8"]["value"] = $node["utf8"]?1:0;
$tags["ordner.erstellungstimestamp"]["auto"] = true;
$tags["ordner.erstellungstimestamp"]["value"] = $folder["cdate"];
$tags["ordner.bearbeitungstimestamp"]["auto"] = true;
$tags["ordner.bearbeitungstimestamp"]["value"] = $folder["edate"];
}

if ($o_type == "obj" && ($o_id["type"] == $T_FILE || $o_id["type"] == $T_IMAGE )) {
$file = get_fileinfo($o_id["id"]);
if ( $file["exists"] ) {
$tags["file.id"]["auto"] = true;
$tags["file.id"]["value"] = $o_id["id"];
$fileurl = make_link("file",$o_id["id"],$node_id,"",$depth);
$tags["file.url"]["auto"] = true;
$tags["file.url"]["value"] = $fileurl;
$tags["file.name"]["auto"] = true;
$tags["file.name"]["value"] = $file["name"];
$tags["file.description"]["auto"] = true;
$tags["file.description"]["value"] = $file["description"];
$tags["file.folder_id"]["auto"] = true;
$tags["file.folder_id"]["value"] = $file["folder_id"];
//                                                          
 $tags["file.size"]["auto"] = true;
$tags["file.size"]["value"] = $file["filesize"];
$tags["file.sizeb"]["auto"] = true;
$tags["file.sizeb"]["value"] = $file["filesize"];
$tags["file.sizeKB"]["auto"] = true;
$tags["file.sizeKB"]["value"] = number_format (ceil($file["filesize"]*10/1024)/10, 1);
$tags["file.sizekb"]["auto"] = true;
$tags["file.sizekb"]["value"] = $tags["file.sizeKB"]["value"]; 
$tags["file.sizeMB"]["auto"] = true;
$tags["file.sizeMB"]["value"] = number_format (ceil($file["filesize"]*10/1024/1024)/10, 1);
$tags["file.sizemb"]["auto"] = true;
$tags["file.sizemb"]["value"] = $tags["file.sizeMB"]["value"]; 
$tags["file.creator"]["auto"] = true;
$tmp = get_userinfo($file["creator"]);
$tags["file.creator"]["value"] = $tmp["fullname"];
$tags["file.creator.email"]["auto"] = true;
$tags["file.creator.email"]["value"] = $tmp["email"];
$tmp = get_userinfo($file["editor"]);
$tags["file.editor"]["auto"] = true;
$tags["file.editor"]["value"] = $tmp["fullname"];
$tags["file.editor.email"]["auto"] = true;
$tags["file.editor.email"]["value"] = $tmp["email"];
$tags["file.createtimestamp"]["auto"] = true;
$tags["file.createtimestamp"]["value"] = $file["cdate"];
//                                                    
 $tags["file.createtimstamp"]["auto"] = true;
$tags["file.createtimstamp"]["value"] = $file["cdate"];
$tags["file.createdate"]["auto"] = true;
$tags["file.createdate"]["value"] = date( "j.n.Y", $file["cdate"] );
$tags["file.edittimestamp"]["auto"] = true;
$tags["file.edittimestamp"]["value"] = $file["edate"];
$tags["file.editdate"]["auto"] = true;
$tags["file.editdate"]["value"] = date( "j.n.Y", $file["edate"] );
$tags["file.type"]["auto"] = true;
$tags["file.type"]["value"] = $file["filetype"];
$tags["file.extension"]["auto"] = true;
$tags["file.extension"]["value"] = strtolower (eregi_replace (".*\.(.*)$", "\\1", $file["name"])); 
if ($o_id["type"] == $T_IMAGE) {
$tags["file.width"]["auto"] = true;
$tags["file.width"]["value"] = $file["sizex"];
$tags["file.height"]["auto"] = true;
$tags["file.height"]["value"] = $file["sizey"];
$tags["file.dpix"]["auto"] = true;
$tags["file.dpix"]["value"] = $file["dpix"];
$tags["file.dpiy"]["auto"] = true;
$tags["file.dpiy"]["value"] = $file["dpiy"];

}
}
}

//                        
 if ($o_type == "obj" && $o_id["type"] == $T_PAGE) {
$page = get_pageinfo($o_id["id"]);
$template = get_templateinfo($page["template_id"]);
//         
 $tags["seite.id"]["auto"] = true;
$tags["seite.id"]["value"] = $page["id"];
//               
 $tags["seite.priority"]["auto"] = true;
$tags["seite.priority"]["value"] = $page["priority"];
//          
 $tags["seite.url"]["auto"] = true;
$tags["seite.url"]["value"] = make_link("page",$page["id"],$node_id,"",$depth);
//             
 $tags["url"] = $tags["seite.url"];
//               
 $tags["seite.filename"]["auto"] = true;
$tags["seite.filename"]["value"] = $page["filename"];
//           
 $tags["seite.name"]["auto"] = true;
$tags["seite.name"]["value"] = $page["name"];
$tags["seitenname"] = $tags["seite.name"];
//                  
 $tags["seite.template_id"]["auto"] = true;
$tags["seite.template_id"]["value"] = $page["template_id"];
//                   
 $tags["seite.beschreibung"]["auto"] = true;
$tags["seite.beschreibung"]["value"] = $page["description"];
$tags["seitenbeschreibung"] = $tags["seite.beschreibung"];
$tags["seite.ordner.id"]["auto"] = true;
$tags["seite.ordner.id"]["value"] = $page["folder_id"];
//                       
 if ($page["cdate"] > 0) {
$tags["seite.erstellungsdatum"]["auto"] = true;
$tags["seite.erstellungsdatum"]["value"] = date("j.n.Y",$page["cdate"]);
//             
 $tags["erstellungsdatum"] = $tags["seite.erstellungsdatum"];
$tags["seite.erstellungstimestamp"]["auto"] = true;
$tags["seite.erstellungstimestamp"]["value"] = $page["cdate"];
}
//                        
 if ($page["edate"] > 0) {
$tags["seite.bearbeitungsdatum"]["auto"] = true;
$tags["seite.bearbeitungsdatum"]["value"] = date("j.n.Y",$page["edate"]);
//             
 $tags["bearbeitungsdatum"] = $tags["seite.bearbeitungsdatum"];
$tags["seite.bearbeitungstimestamp"]["auto"] = true;
$tags["seite.bearbeitungstimestamp"]["value"] = $page["edate"];
}
//                              
 if ($page["pdate"] > 0) {
$tags["seite.veroeffentlichungsdatum"]["auto"] = true;
$tags["seite.veroeffentlichungsdatum"]["value"] = date("j.n.Y",$page["pdate"]);
//             
 $tags["veroeffentlichungsdatum"] = $tags["seite.veroeffentlichungsdatum"];
$tags["seite.veroeffentlichungstimestamp"]["auto"] = true;
$tags["seite.veroeffentlichungstimestamp"]["value"] = $page["pdate"];
}
//                
 if ($page["creator"] > 0) {
$user = get_userinfo($page["creator"]);
$tags["seite.ersteller"]["auto"] = true;
$tags["seite.ersteller"]["value"] = $user["firstname"]." ".$user["lastname"];
$tags["seite.ersteller.email"]["auto"] = true;
$tags["seite.ersteller.email"]["value"] = $user["email"];
//             
 $tags["seitenersteller"] = $tags["seite.ersteller"];
}
//                 
 if ($page["editor"] > 0) {
$user = get_userinfo($page["editor"]);
$tags["seite.bearbeiter"]["auto"] = true;
$tags["seite.bearbeiter"]["value"] = $user["firstname"]." ".$user["lastname"];
//             
 $tags["seitenbearbeiter"] = $tags["seite.bearbeiter"];
$tags["seite.bearbeiter.email"]["auto"] = true;
$tags["seite.bearbeiter.email"]["value"] = $user["email"];
}
//                       
 if ($page["publisher"] > 0) {
$user = get_userinfo($page["publisher"]);
$tags["seite.veroeffentlicher"]["auto"] = true;
$tags["seite.veroeffentlicher"]["value"] = $user["firstname"]." ".$user["lastname"];
//              
 $tags["seitenveroeffentlicher"] = $tags["seite.veroeffentlicher"];
$tags["seite.veroeffentlicher.email"]["auto"] = true;
$tags["seite.veroeffentlicher.email"]["value"] = $user["email"];
}
//            
 $tags["seite.ml_id"]["auto"] = true;
$tags["seite.ml_id"]["value"] = $template["ml_id"];
//        
 $tags["seite.sprach_id"]["auto"] = true;
$tags["seite.sprach_id"]["value"] = $page["contentgroup_id"];
$tags["seite.sprache"]["auto"] = true;
$tags["seite.sprache"]["value"] = $CONTENTGROUPS[$page["contentgroup_id"]]['name'];
$tags["seite.languageset.id"]["auto"] = true;
$tags["seite.languageset.id"]["value"] = $page["contentset_id"];
$tags["seite.sprach_code"]["auto"] = true;
$tags["seite.sprach_code"]["value"] = $CONTENTGROUPS[$page["contentgroup_id"]]['code'];

//                
 $tags["seite.sprachvarianten"]["auto"] = true;
if ($page["contentset_id"]) {
$sql = "SELECT id, name, contentgroup_id FROM page WHERE contentset_id = ".sqlf_tl_num($page["contentset_id"]);
$rs = query($sql,true);//            
 $cs = Array();
while (list($key,$val) = each($rs["arr"])) {
$tmp = Array();
$tmp[0] = make_link("page",$val["id"],$node_id,"",$depth);
$tmp[1] = $val["name"];
$cs[$val["contentgroup_id"]] = $tmp;
$tags["seite.sprachen.".$CONTENTGROUPS[$val["contentgroup_id"]]['code'].'.id']["auto"] = true;
$tags["seite.sprachen.".$CONTENTGROUPS[$val["contentgroup_id"]]['code'].'.id']["value"] = $val["id"]; 
$tags["seite.sprachen.".$CONTENTGROUPS[$val["contentgroup_id"]]['code'].'.url']["auto"] = true;
$tags["seite.sprachen.".$CONTENTGROUPS[$val["contentgroup_id"]]['code'].'.url']["value"] = $tmp[0]; 
$tags["seite.sprachen.".$CONTENTGROUPS[$val["contentgroup_id"]]['code'].'.name']["auto"] = true;
$tags["seite.sprachen.".$CONTENTGROUPS[$val["contentgroup_id"]]['code'].'.name']["value"] = $tmp[1]; 
}
$cs = serialize($cs);
} else $cs = "";
$tags["seite.sprachvarianten"]["value"] = $cs;

if ($_ottime1) {
$_t4 = microtime();
$TS["ot_tagsset"] += calctime($_t1,$_t4,12);
}

}

if ($_ottime1) $_t3 = microtime();

if ($FEATURE["objtranslatecache"] && !$edit && $cachetype && !$DEBUG["skip_objtranslatecache"]) {
//                                                                                     
 //                                        
 $cachetags = $tags;
if ($PUBWAY == "dyn" || $PUBWAY == "real") {
while (list($key,$val) = each($cachetags)) {
$cachetags[$key] = str_replace($SESSION_TOKEN,"OBJTRANSLATECACHESID",$val);
}
}
$sql = "INSERT INTO objtranslatecache (o_id,o_type,cachekey,value_tags) VALUES (".sqlf_tl_num($cacheid).",".sqlf_tl_num($cachetype).",'".sqlslashes($cachekey)."','".sqlslashes(serialize($cachetags))."')";
query($sql);//            
 }

if ($_ottime) {
$_t2 = microtime();
if ($_ottime1) $TS["ot_infos"] += calctime($_t3,$_t2,12);
$TS["ot"] += calctime($_t1,$_t2,12);
$TS["otc"]++;
}
return $tags;

}

function part_translate($type, $val_text, $val_ref, $info, $keyword = "", $info_int=0, $info_text="", $tagtable = "", $tag_id = 0, $enabled = false, $part_prop = Array(), $pid = 0, $name = "", $o_type = "", $mother_id = 0, $mother_type = "", $depth = 0, $edit =false, $cid = 0, $node_id = 0, $partorder = 0, $tagtype = "") {

global $STAG, $CONSTRUCT_PARTS, $T_PAGE, $T_FOLDER, $DO, $TS, $DEBUG, $TAG_PREFIX, $T_FILE, $T_IMAGE, $FEATURE, $T_TEMPLATE, $T_CONTENT, $T_CONTENTTAG, $T_TEMPLATETAG, $T_OBJTAG, $FEATURE;

$isUTF8 = true;

if ($tagtype == "content") {
$t_tag = $T_CONTENTTAG;
}
if ($tagtype == "template") {
$t_tag = $T_TEMPLATETAG;
}
if ($tagtype == "obj") {
$t_tag = $T_OBJTAG;
}

//                                 
 if ($mother_type == "page") {
$t_mother = $T_PAGE;
$t_mother_id = $mother_id;
}
if ($mother_type == "template") {
$t_mother = $T_TEMPLATE;
$t_mother_id = $mother_id;
}
if ($mother_type == "file" ) {

$t_mother = $T_FILE;
$t_mother_id = $mother_id;
}

if ($FEATURE["xnl"]) {
static $xnlParser;

if (!is_object($xnlParser)) {
$xnlParser = &ParserFactory::getInstanceOf("xnl");
}
$xnlErrorPrefix = $xnlParser->getErrorPrefix();
$xnlParser->setErrorPrefix( i18n( "Tag {0}",0,$name."($keyword)" ) );
}

if ($o_type == "content") $t_tag = $T_CONTENTTAG;
if ($o_type == "template") $t_tag = $T_TEMPLATETAG;
if ($o_type == "obj") $t_tag = $T_OBJTAG;

$_ottime = $DEBUG["time_parttranslate"];
$_ottime1 = $DEBUG["time_parttranslate_detail"];

if (!$_ottime) $_ottime1 = false;

if ($_ottime) $_t1 = microtime();

//     
 if ($type == 1 || $type == 37) {
$val = mynl2br($val_text);
$part_prop[$keyword] = $val;
}

//     /    
 if ($type == 2 || $type == 10 || $type == 26) {
$val = textnl2br($val_text);
$part_prop[$keyword] = $val;
}

//               
 if ($type == 3 || $type == 21 || $type == 27 || $type == 36) {
$val = $val_text;
$part_prop[$keyword] = $val;
}

//         
 if ($type == 22) {
$val = str_replace("\\","/",substr($val_text,2));
//                          
 //                          /        
 $val = "file://".$val;
$part_prop[$keyword] = $val;
}

//    
 if ($type == 4) {
//             
 if ($val_ref > 0 && $info == 1) {
$val = make_link("page",$val_ref,$node_id,"",$depth);
$page = get_pageinfo($val_ref);
$part_prop[$keyword.".name"] = $page["name"];
$part_prop[$keyword.".description"] = $page["description"];
$part_prop[$keyword.".filename"] = $page["filename"];
$part_prop[$keyword.".id"] = $page["id"];
$part_prop[$keyword.".folder_id"] = $page["folder_id"];
$part_prop[$keyword.".priority"] = $page["priority"];
$part_prop[$keyword.".isinternal"] = 1;
$tmp = get_folderinfo($page["folder_id"]);
$part_prop[$keyword.".node_id"] = $tmp["node_id"];

//       
 //                                

//                                                                              
$stat = get_page_stat($val_ref);
//     

//             
 } else if ($val_text && $info == 0) {
$val = $val_text;
$part_prop[$keyword.".isinternal"] = 0;
}
$part_prop[$keyword] = $val;
}

//             
 if ($type == 5) {
if ($val_ref) {
if (!$GLOBALTAG_VISITED[$val_ref]) {
$GLOBALTAG_VISITED[$val_ref] = true;

if ($_ottime) {
$_t2 = microtime();
$TS["pt"] += calctime($_t1,$_t2,12);
}

$tmp = obj_translate($val_ref,"globaltag",$mother_id,$mother_type,$node_id,$edit,$depth+1);

if ($_ottime) $_t1 = microtime();
}
}
else $tmp[0]["value"] = "";
if (is_array($tmp)) list($key,$tmp) = each($tmp);
$val = $tmp["value"];
$part_prop[$keyword] = $val;
}

//            
 if ($type == 6) {
//             
 if ($val_ref > 0){
$val = make_link("file",$val_ref,$node_id,"",$depth);
$file = get_fileinfo($val_ref);
$part_prop[$keyword] = $val;
$part_prop[$keyword.".id"] = $file["id"];
$part_prop[$keyword.".name"] = $file["name"];
$part_prop[$keyword.".description"] = $file["description"];
$part_prop[$keyword.".sizeb"] = $file["filesize"];
$part_prop[$keyword.".sizeKB"] = number_format (ceil($file["filesize"]*10/1024)/10, 1);
$part_prop[$keyword.".sizekb"] = $part_prop[$keyword.".sizeKB"];
$part_prop[$keyword.".sizeMB"] = number_format (ceil($file["filesize"]*10/1024/1024)/10, 1);
$part_prop[$keyword.".sizemb"] = $part_prop[$keyword.".sizeMB"];
$part_prop[$keyword.".folder_id"] = $file["folder_id"];
$part_prop[$keyword.".edittimestamp"] = $file["edate"];
$part_prop[$keyword.".createtimestamp"] = $file["cdate"];
$part_prop[$keyword.".type"] = $file["filetype"];
$part_prop[$keyword.".extension"] = strtolower (eregi_replace (".*\.(.*)$", "\\1", $file["name"])); 
$part_prop[$keyword.".width"] = $file["sizex"];
$part_prop[$keyword.".height"] = $file["sizey"];
$part_prop[$keyword.".dpix"] = $file["dpix"];
$part_prop[$keyword.".dpiy"] = $file["dpiy"];
if ( $file["dpix"] == $file["dpiy"] )
$part_prop[$keyword.".dpi"] = $file["dpix"];
else
$part_prop[$keyword.".dpi"] = $file["dpix"]."x".$file["dpiy"];
$part_prop[$keyword.".encoded"] = urlencode($val);
if ($part_prop[$keyword.".sizemb"] > 1) $part_prop[$keyword.".size"] = $part_prop[$keyword."sizemb"]." MB";
else $part_prop[$keyword.".size"] = $part_prop[$keyword."sizekb"]." KB";
$tmp = Array();
$tmp["id"] = $val_ref;
$tmp["type"] = $T_IMAGE;
$imgtags = obj_translate($tmp,"obj",$mother_id,$mother_type,$node_id,$edit,$depth+1);
while (list($k,$v) = each($imgtags)) {
$part_prop[$keyword.".".$k] = $v["value"];
}
}
}

//           
 if ($type == 8 || $type == 14) {

//             
 if ($val_ref > 0) {
$val = make_link("file",$val_ref,$node_id,"",$depth);
$file = get_fileinfo($val_ref);
if ($type == 14) $val = str_replace("%","�",rawurlencode($val));
$part_prop[$keyword] = $val;
$part_prop[$keyword.".id"] = $val_ref;
$part_prop[$keyword.".name"] = $file["name"];
$part_prop[$keyword.".description"] = $file["description"];
$part_prop[$keyword.".sizeb"] = $file["filesize"];
$part_prop[$keyword.".sizeKB"] = number_format (ceil($file["filesize"]*10/1024)/10, 1);
$part_prop[$keyword.".sizekb"] = $part_prop[$keyword.".sizeKB"];
$part_prop[$keyword.".sizeMB"] = number_format (ceil($file["filesize"]*10/1024/1024)/10, 1);
$part_prop[$keyword.".sizemb"] = $part_prop[$keyword.".sizeMB"];
$part_prop[$keyword.".folder_id"] = $file["folder_id"];
$part_prop[$keyword.".edittimestamp"] = $file["edate"];
$part_prop[$keyword.".createtimestamp"] = $file["cdate"];
$part_prop[$keyword.".type"] = $file["filetype"];
$part_prop[$keyword.".extension"] = strtolower (eregi_replace (".*\.(.*)$", "\\1", $file["name"])); 
$part_prop[$keyword.".encoded"] = urlencode($val);
if ($part_prop[$keyword.".sizemb"] > 1) $part_prop[$keyword.".size"] = $part_prop[$keyword.".sizemb"]." MB";
else $part_prop[$keyword.".size"] = $part_prop[$keyword.".sizekb"]." KB";
}
}

//             
 if ($type == 25) {
if ($val_ref > 0) {
$folder = get_folderinfo($val_ref);
$val = make_link("folder",$val_ref,$node_id,"",$depth);
$part_prop[$keyword.".name"] = $folder["name"];
$part_prop[$keyword.".description"] = $folder["description"];
$part_prop[$keyword.".mother"] = $folder["mother"];
$part_prop[$keyword.".node_id"] = $folder["node_id"];
$part_prop[$keyword.".id"] = $val_ref;
}
}

//             
 if ($type == 9) {
$val = $val_text;
$part_prop[$keyword] = $val;
}

//           
 if ($type == 11) {
if ($val_ref) {
if (!$TAG_VISITED[$t_tag][$tag_id]) {
$TAG_VISITED[$t_tag][$tag_id] = true;
$_page = get_pageinfo($info);
$part_prop[$keyword.".page_id"] = $info;
$part_prop[$keyword.".id"] = $val_ref;
$_tid = $_page["tid"];
$_cid = $_page["cid"];
if ($val_ref) {
$sqlpart = "contenttag";
$targettype = $T_PAGE;
if ($val_text == "t") {
$sqlpart = "templatetag";
$targettype = $T_TEMPLATE;
}
$sql = "SELECT name, construct_id FROM $sqlpart WHERE id = ".sqlf_tl_num($val_ref);
$rs = query($sql,true);//            
 $_name = $rs["arr"][0]["name"];
$_tag_info = get_taginfo($tag_id,$tagtype,"ds");
$target_is_ds = $_tag_info["detail"];
if ($_tid && $_cid) {

//                      

if ($_ottime) {
$_t2 = microtime();
$TS["pt"] += calctime($_t1,$_t2,12);
}

$_tags = translate_pagecontent($info,false,$depth+1,$node_id);

if ($_ottime) $_t1 = microtime();

//                        
 while(list($key,$val) = each($_tags)) {
if (substr($key,0,strlen($_name)) == $_name) {
$part_prop[$keyword.substr($key,strlen($_name)+1)] = $val["value"];
}
}
reset($_tags);

$tag_code = "<$TAG_PREFIX $_name>";
if ($target_is_ds) $tag_code .= "</$TAG_PREFIX $_name>";
$val = code_translate($tag_code,$_tags,"page", false, Array(), $t_mother, $t_mother_id, false, $node_id);

//           
 if ($FEATURE["xnl"]) {
$baseObj = new CNPageObject($info);
$props =& $xnlParser->getObjectParser("prop");
$props->setObject("this",$baseObj);
if ($mother_type == "page") {
$container = new CNPageObject($mother_id);
$props->setObject("container",$container);
} else if ($mother_type == "template") {
$container = new CNTemplateObject($mother_id);
$props->setObject("container",$container);
}

$val = $xnlParser->parse($val);
$props->unsetObject("this");
$props->unsetObject("container");
}

}
}
$TAG_VISITED[$t_tag][$tag_id] = false;
}
} else $val = "";
$part_prop[$keyword] = $val;
}

//               
 if ($type == 20) {
if ($val_ref) {
if (!$TAG_VISITED[$t_tag][$tag_id]) {
$TAG_VISITED[$t_tag][$tag_id] = true;
$sql = "SELECT name, template_id FROM templatetag WHERE id = ".sqlf_tl_num($val_ref);
$rs = query($sql,true);//            
 $_name = $rs["arr"][0]["name"];
$_tid = $rs["arr"][0]["template_id"];

if ($_ottime) {
$_t2 = microtime();
$TS["pt"] += microtime();
}

$_tags = obj_translate($_tid,"template",$_tid,"template",$node_id,false,$depth+1);

if ($_ottime) $_t1 = microtime();

//                        
 while(list($key,$val) = each($_tags)) {
if (substr($key,0,strlen($_name)) == $_name) {
$part_prop[$keyword.substr($key,strlen($_name)+1)] = $val["value"];
}
}
reset($_tags);

$tagsource = "<$TAG_PREFIX $_name>";
$taginfo = get_taginfo($tag_id,$tagtype,"ds");
if ($taginfo["detail"]) $tagsource .= "</$TAG_PREFIX $_name>";

$val = code_translate($tagsource,$_tags,"page", false, Array(), $t_mother, $t_mother_id, false, $node_id);

//           
 if ($FEATURE["xnl"]) {
$baseObj = new CNTemplateObject($info);
$props =& $xnlParser->getObjectParser("prop");
$props->setObject("this",$baseObj);
if ($mother_type == "page") {
$container = new CNPageObject($mother_id);
$props->setObject("container",$container);
} else if ($mother_type == "template") {
$container = new CNTemplateObject($mother_id);
$props->setObject("container",$container);
}

$val = $xnlParser->parse($val);
$props->unsetObject("this");
$props->unsetObject("container");
}

$TAG_VISITED[$t_tag][$tag_id] = false;
}
} else $val = "";
$part_prop[$keyword] = $val;
}

//      
 if ($type == 12) {
$isUTF8 = false;
$_size = explode(";",$val_text);

if ($o_type == "template" || $o_type == "template_nopub") $_part = "templatetag";
else if ($o_type == "page") $_part = "contenttag";
else $_part = $tagtable;
$sql = "SELECT th, td_f_even, td_f_odd, th_f, td_type, th_type, table_f FROM contenttable 
WHERE ".sqlf_name($_part)."_id = ".sqlf_tl_num($tag_id)." AND part_id = ".sqlf_tl_num($pid);
$rs = query($sql);//            
 if ($rs["arr"]) {
$row = $rs["arr"][0];
$th = $row["th"];
$td_f_even = $row["td_f_even"];
$td_f_odd = $row["td_f_odd"];
$th_f = $row["th_f"];
$table_f = $row["table_f"];
}

$val = "<table $table_f>\n";
if ($th) $_r = 0;
else $_r = 1;
for ($r = $_r; $r <= $_size[1]; $r++) {

if ($r % 2) $td_f = $td_f_odd;
else $td_f = $td_f_even;
$val .= "<tr>\n";
for ($c = 1; $c <= $_size[0]; $c++) {
if ($r > 0) $val .= "<td $td_f>\n";
else $val .= "<th $th_f>\n";
$val .= "<$TAG_PREFIX ".$name."_".$r."_".$c.":nbsp>";
if ($r > 0) $val .= "</td>\n";
else $val .= "</th>\n";
}
$val .= "</tr>\n";
}
$val .= "</table>\n";
$part_prop[$keyword] = $val;
}

//          
 if ($type == 23) {
$isUTF8 = false;
ereg("^[^\.]*\.([0-9A-Z]*)\.",$name,$_cell);
$_cell = $_cell[1];
if (is_numeric($_cell[0])) $_row = $_cell;
else {
$_row = substr($_cell,1);
$_col = ord($_cell[0])-64;
}

if (!$_row) $_row = 0;
if (!$_col) $_col = 0;
//                                                  
//                                              
//                         
 //                          
 $part_prop["col"] = (int)$_col;
$part_prop["row"] = (int)$_row;

if (is_false(strpos($name,"."))) {

$_size = explode(";",$val_text);
if (!$_size[0]) $_size[0] = 0;
if (!$_size[1]) $_size[1] = 0;
$parts = $CONSTRUCT_PARTS[$cid];

//                  
 $sql = "SELECT keyword FROM part WHERE part.construct_id = ".sqlf_tl_num($cid);
$rs = query($sql, true);//            
 $parts = $rs["arr"];

// ###                                            
 $cell_head = array();

//                     
 $sql = "SELECT id FROM part WHERE construct_id = ".sqlf_tl_num($cid)." AND keyword = 'td.header'";
$rs = query($sql, true);//            
 if ($rs["num"]) {
$header_pid = $rs["arr"][0]["id"];

//                      
 $sql = "SELECT c2.id, c2.name, v.value_text, p.type_id, p.info_int
              FROM contenttag c1 
              LEFT JOIN contenttag c2 ON c1.content_id = c2.content_id 
              LEFT JOIN value v on v.contenttag_id = c2.id 
	      LEFT JOIN part p on p.id = v.part_id
              WHERE c1.id = ".sqlf_tl_num($tag_id)." AND part_id = ".sqlf_tl_num($header_pid)." AND c2.name LIKE '".sqlf_escaped($name)."%'";
$rs = query($sql, true);//            

if ($rs["num"]) {

//                                  
 reset ($rs["arr"]);

while (list($key, $val) = each ($rs["arr"]))
{
//                              
 if ($val["type_id"] == 29)
{
node_class( "sourcefactory" );
$source =& SourceFactory::loadSingle( $val["info_int"] );

if ( $source )
$list = $source->export();

$cell_head[$val["name"]] = $list[$val["value_text"]]["value"];
}

else
$cell_head[$val["name"]] = $val["value_text"];
}

//                                                          
 }
}

//                  
 //                                                                                                                                                                             
 //       

if (is_array($parts)) {
//                                  

$table_plus = "";
$props = Array();
reset($parts);
while (list($k, $v) = each($parts)) {
//                   *                                                         
 $props[] = $v["keyword"];
if (!is_false(strpos($v["keyword"],"table."))) {
$tab_prop = str_replace("table.","",$v["keyword"]);
$_tag = "$name.".$v["keyword"];
//                                               
 $_code = "<$TAG_PREFIX $_tag>"; 
//                                     
 $table_f .= $_code;
}
if (!is_false(strpos($v["keyword"],"table+."))) {
$tab_prop = str_replace("table+.","",$v["keyword"]);
$_tag = "$name.".$v["keyword"];
//                                         /             
 $_code = "<$TAG_PREFIX $_tag>"; 
//                                     
 $table_plus .= $_code;
}
//    
 if (!is_false(strpos($v["keyword"],"tr."))) {
$tr_prop = str_replace("tr.","",$v["keyword"]);
$_tag = "$name.\$row.style.".$v["keyword"];
//                                                  
 $_code = "<$TAG_PREFIX $_tag>"; 
//                                  
 $tr_f .= $_code;
}
if (!is_false(strpos($v["keyword"],"td."))) {
$td_prop = str_replace("td.","",$v["keyword"]);
$_tag = "$name.\$col\$row.style.".$v["keyword"];
//                                                 
 $_code = "<$TAG_PREFIX $_tag>";
//                                  
 if ($td_prop == "scope") {
$th_f .= $_code;
}
//                                      
 else if ($td_prop != "header") {
$td_f .= $_code;
}

}
// 
 }
}

global $COLOR, $JS;
$editcol = $COLOR["selection_bg"];
//                                             
 $info_text = explode(';',$info_text);
if (is_false(strpos($name,"."))) {
$editmod .= "
var mark_col_".$name." = '$editcol';
var tab_$name;

function mark_".$name."() {
  var cols_".$name." = false;
  var rows_".$name." = false;
  var col_".$name." = Array();
  var row_".$name." = Array();
  for (i=0;i<=".(int)$_size[0]."-1;i++) {
	if (document.form_".$name.") if (document.form_".$name.".elements) if (document.form_".$name.".elements[i]) if (document.form_".$name.".elements[i].checked) {
	  cols_".$name." = true;
	  col_".$name."[i+1] = true;
	}
  }
  for (j=i;j<".(int)$_size[1]."+i;j++) {
	if (document.form_".$name.".elements[j]) if (document.form_".$name.".elements[j].checked) {
	  rows_".$name." = true;
	  row_".$name."[j+1-i] = true;
	}
  }
  // clean up the cells
  for (i=1;i<=".(int)$_size[0].";i++) {
	for (j=1;j<=".(int)$_size[1].";j++) {
	  if (document.getElementById) document.getElementById('$name-'+i+'-'+j).style.backgroundColor = \"\";
	}
  }
  // select the cells
  if (cols_".$name." && rows_".$name.") {
	for (i=1;i<=".(int)$_size[0].";i++) {
	  if (col_".$name."[i]) {
		for (j=1;j<=".(int)$_size[1].";j++) {
		  if (row_".$name."[j]) {
			if (document.getElementById) { 
			  document.getElementById('$name-'+i+'-'+j).style.backgroundColor = mark_col_".$name.";
			}
		  }
		}
	  }
	}
	clear_".$name."_opt();
	c=0;
	document.form_".$name.".opt_".$name.".options[c]=new Option('".i18n('tblext ---action cell---')."');
	document.form_".$name.".opt_".$name.".options[c++].selected = true;
	document.form_".$name.".opt_".$name.".options[c]=new Option('".i18n('tblext format')."');
	document.form_".$name.".opt_".$name.".options[c++].value='cell_format';";

if (!$info_text[2] && $info_text[2] != -9999) {
$editmod .= "
	document.form_".$name.".opt_".$name.".options[c]=new Option('".i18n('tblext define tagtype')."');
	document.form_".$name.".opt_".$name.".options[c++].value='cell_tag';";
}

$editmod .= "
  } else if (cols_".$name.") {
	for (i=1;i<=".(int)$_size[0].";i++) {
	  if (col_".$name."[i]) {
		for (j=1;j<=".(int)$_size[1].";j++) {
		  if (document.getElementById) {
			document.getElementById('$name-'+i+'-'+j).style.backgroundColor = mark_col_".$name.";
		  }
		}
	  }
	}
	clear_".$name."_opt();
	c=0;
	document.form_".$name.".opt_".$name.".options[c]=new Option('".i18n('tblext ---action column---')."');
	document.form_".$name.".opt_".$name.".options[c++].selected = true;
	document.form_".$name.".opt_".$name.".options[c]=new Option('".i18n('tblext format')."');
	document.form_".$name.".opt_".$name.".options[c++].value='col_format';";
if (!$info_text[2] && $info_text[2] != -9999) {
$editmod .= "
	document.form_".$name.".opt_".$name.".options[c]=new Option('".i18n('tblext define tagtype')."');
	document.form_".$name.".opt_".$name.".options[c++].value='col_tag';";
}

if (!$info_text[0]) {
$editmod .= "
	document.form_".$name.".opt_".$name.".options[c]=new Option('".i18n('tblext insert')."');
	document.form_".$name.".opt_".$name.".options[c++].value='col_insert';
	document.form_".$name.".opt_".$name.".options[c]=new Option('".i18n('tblext delete')."');
	document.form_".$name.".opt_".$name.".options[c++].value='col_delete';";
}

$editmod .= "
	document.form_".$name.".opt_".$name.".options[c]=new Option('".i18n('tblext move')."');
	document.form_".$name.".opt_".$name.".options[c++].value='col_move';
  } else if (rows_".$name.") {
	for (i=1;i<=".$_size[0].";i++) {
	  for (j=1;j<=".$_size[1].";j++) {
		if (row_".$name."[j]) { 
		  if (document.getElementById) {
			document.getElementById('$name-'+i+'-'+j).style.backgroundColor = mark_col_".$name.";
		  }
		}
	  }
	}
	clear_".$name."_opt();
	c=0;
	document.form_".$name.".opt_".$name.".options[c]=new Option('".i18n('tblext ---action row---')."');
	document.form_".$name.".opt_".$name.".options[c++].selected = true;
	document.form_".$name.".opt_".$name.".options[c]=new Option('".i18n('tblext format')."');
	document.form_".$name.".opt_".$name.".options[c++].value='row_format';";
if (!$info_text[2] && $info_text[2] != -9999) {
$editmod .= "
	document.form_".$name.".opt_".$name.".options[c]=new Option('".i18n('tblext define tagtype')."');
	document.form_".$name.".opt_".$name.".options[c++].value='row_tag';";
}

if (!$info_text[1]) {
$editmod .= "
	document.form_".$name.".opt_".$name.".options[c]=new Option('".i18n('tblext insert')."');
	document.form_".$name.".opt_".$name.".options[c++].value='row_insert';
	document.form_".$name.".opt_".$name.".options[c]=new Option('".i18n('tblext delete')."');
	document.form_".$name.".opt_".$name.".options[c++].value='row_delete';";
}

$editmod .= "
	document.form_".$name.".opt_".$name.".options[c]=new Option('".i18n('tblext move')."');
	document.form_".$name.".opt_".$name.".options[c++].value='row_move';
  } else {
	clear_".$name."_opt();
	document.form_".$name.".opt_".$name.".options[0]=new Option('---');
	document.form_".$name.".opt_".$name.".options[0].selected = true;
  }
}
function clear_".$name."_opt() {
  for (i=document.form_".$name.".opt_".$name.".length;i>0;i--) {
	document.form_".$name.".opt_".$name.".options[i-1]=null;
  }
  document.form_".$name.".opt_".$name.".options[0]=new Option('---');
  document.form_".$name.".opt_".$name.".options[0].selected = true;
}
function edit_".$name."(what){
  // get parameters
  var sel='';
  for (i=0;i<=".(int)$_size[0]."-1;i++) {
	if (document.form_".$name.".elements[i]) if (document.form_".$name.".elements[i].checked) {
	  sel += '&t_col['+String.fromCharCode(i+65)+']=1';
	}
  }
  for (j=i;j<".(int)$_size[1]."+i;j++) {
	if (document.form_".$name.".elements[j]) if (document.form_".$name.".elements[j].checked) {
	  sel += '&t_row['+(j-i+1)+']=1';
	}
  }
  document.form_".$name.".opt_".$name.".selectedIndex=0;
  link_format='$STAG&do=10008&id=$tag_id&type=$mother_type&keepsid=1&redo=$DO';
  link_modify='$STAG&do=17100&id=$tag_id&type=$mother_type&redo=$DO&edit=';
  switch (what) {
  case 'cell_format':
  case 'col_format':
  case 'row_format':
	hopedit(link_format+sel);
	break;
  case 'cell_tag':
  case 'col_tag':
  case 'row_tag':
	hopdialog(link_modify+what+sel,380,210);
	break;
  case 'col_insert':
  case 'row_insert':
	hopdialog(link_modify+what+sel,375,220);
	break;
  case 'col_move':
  case 'row_move':
	hopdialog(link_modify+what+sel,375,250);
	break;
  case 'col_delete':
  case 'row_delete':
	hopdialog(link_modify+what+sel,375,180);
	break;
  default:
	return false;
	break;
  }
}
";
}
if ($edit) $JS .="$editmod";
if ($edit) $val .= "\n<form name=\"form_".$name."\">";
$val .= "<table$table_f>\n";
$val .= "$table_plus\n";
if ($th) $_r = 0;
else $_r = 1;
//           
 if ($edit) {
$val .= "<tr bgcolor=\"$editcol\" id=\"".$name."_markhead\">\n";
$edit_link="$STAG&do=10008&id=$tag_id&type=$o_type&keepsid=1&t_table=1";
global $ICO_TAB_FORMAT;
$val .= "<td nowrap align=\"center\" valign=\"middle\" width=\"1%\"><a href=\"javascript:hopedit('$edit_link')\">".img($ICO_TAB_FORMAT)."</a></td>";
for ($c = 1; $c <= $_size[0]; $c++) {
$col = chr(64+$c);
$val .= "<td align=\"center\" nowrap>
<input type=checkbox onclick=\"mark_".$name."();\">$col</td>\n";
}
$val .= "</tr>\n";
}
//               

for ($r = $_r; $r <= $_size[1]; $r++) {
$row = $r;
eval("\$_tr_f = \"$tr_f\";");
$val .= "<tr$_tr_f>\n";
//           
 if ($edit) {
//                                                                            
 $val .= "<td id=\"".$name."_mark$r\" valign=\"middle\" align=\"right\" bgcolor=\"$editcol\" nowrap  width=\"1%\">
<input type=checkbox onClick=\"mark_".$name."();\">$row&nbsp;</td>\n";
}
//               
 for ($c = 1; $c <= $_size[0]; $c++) {
//                     
 $col = chr(64+$c);

//               
 eval("\$_td_f = \"$td_f\";");
eval("\$_th_f = \"$th_f\";");
//                            
 if ($edit) {
$_td_f = " id=\"".$name."-$c-$r\"$_td_f";
}

//                       /   
 $cell_key_img = "";
//                                                    
 //                                                           /                              
 if ($r > 0 && (!$cell_head["$name.$col$row.style"] || $cell_head["$name.$col$row.style"] == "-9999")) {
$cell_key = "td";
} else {
$cell_key = "th";
if ($edit) $cell_key_img = "<br>[header]";
}

// ###           
 if ($cell_key == "th") {
$val .= "<${cell_key}$_td_f"."$_th_f>\n";
}
else {
$val .= "<${cell_key}$_td_f>\n";
}
// ###             
 $val .= "<$TAG_PREFIX ".$name.".".$col.$row.":nbsp>";
// ###         
 $val .= "$cell_key_img</$cell_key>\n";
}
//               
 $val .= "</tr>\n";
}

if ($edit) {
$val .= "<tr><td id=\"".$name."_markfoot\" bgcolor=\"$editcol\" nowrap colspan=".($c++).">
<select name=\"opt_".$name."\" onChange=\"return edit_".$name."(document.form_".$name.".opt_".$name.".options[document.form_".$name.".opt_".$name.".selectedIndex].value);\">
<option>-------------------------</option>
<option>-</option>
<option>-</option>
<option>-</option>
<option>-</option>
<option>-</option>
<option>-</option>
</select></td></tr>\n";
}
$val .= "</table>\n";
if ($edit) 
$val .= "</form>
<script type=\"text/javascript\">
clear_".$name."_opt();
</script>
";
$part_prop[$keyword] = $val;
//                 
 }

}

//           
 if ($type == 13) {
$isUTF8 = false;
if (!$TAG_VISITED[$t_tag][$tag_id]) {

$TAG_VISITED[$t_tag][$tag_id] = true;

$sql = "SELECT is_folder, o_type, orderkind, orderway, max_obj, recursion FROM ds WHERE ".sqlf_name($tagtable)."_id = ".sqlf_tl_num($tag_id);
$rs = query($sql);//            
 if ($rs["num"] > 0) {
//                 
 $construct_val_text = '';
$template_val_text = '';
$page_val_text = '';
$object_val_text = '';

//                                 
 $sql = "SELECT value.value_text, value.info  FROM value, part
		WHERE value.part_id = part.id AND templatetag_id = 0 AND contenttag_id = 0 AND objtag_id = 0 AND value.part_id = ".sqlf_tl_num($pid);
$rs_z = query($sql);//            
 $changeable = $rs_z["arr"][0]["info"];
$construct_val_text = $rs_z["arr"][0]["value_text"];	

decho ("changeable($changeable) o_type($o_type) mother_type($mother_type)<br>", "ds"); //      

if ( $o_type == "template" || $o_type == "template_nopub" ) {
//                                                
 $sql = "SELECT value.value_text FROM value, part
			WHERE value.templatetag_id = ".((int)$tag_id)." 
			AND value.part_id = part.id AND part.type_id = 13";
$rs_t = query($sql);//            
 $template_val_text = $rs_t["arr"][0]["value_text"];
decho("get templatetag ds source:<br>----&gt;".htmlentities($template_val_text)."<br>&lt;----<br>" ,"ds");
} else if ($o_type == "content" && $mother_type == "page") {

decho("o_type = content && mother_type == page" ,"ds");

$_page = get_pageinfo($mother_id);

if ($_page) {
//                                                
 $sql = "SELECT value.value_text FROM templatetag, value, part
				WHERE template_id = ".sqlf_tl_num($_page["template_id"])." AND name = '".sqlf_escaped($name)."'
				AND value.part_id = part.id AND part.type_id = 13
				AND value.templatetag_id = templatetag.id";
$rs_t = query($sql);//            
 $template_val_text = $rs_t["arr"][0]["value_text"];
decho("get templatetag ds source:<br>----&gt;".htmlentities($template_val_text)."<br>&lt;----<br>" ,"ds");
/* 
 *                                                                    

                                                                               
     //                            
                                                   
                                                                       
     //                    //                  
                                  
                             
      
      
     
*/					
//                                              
 if ( $FEATURE["dssource"] ) {
$sql = "SELECT value.value_text FROM contenttag, value, part
					WHERE content_id = ".sqlf_tl_num($_page['content_id'])." AND name = '".sqlf_escaped($name)."' AND 
					value.part_id = part.id AND part.type_id = 13
					AND value.contenttag_id = contenttag.id";
$rs_t = query($sql);//            
 $page_val_text = $rs_t["arr"][0]["value_text"];
decho("get pagetag ds source:<br>----&gt;".htmlentities($rs_t["arr"][0]["value_text"])."<br>&lt;----<br>" ,"ds");
}
}
}

//                                                                      
 //                                                                                  
 if ($tagtable == 'objtag' && $FEATURE["dssource"] ) {
$sql = "SELECT value.value_text FROM objtag, value, part
			WHERE objtag.id = ".sqlf_tl_num($tag_id)." AND name = '".sqlf_escaped($name)."' AND 
			value.part_id = part.id AND part.type_id = 13
			AND value.objtag_id = objtag.id";
$rs_o = query($sql);//            
 decho("get objecttag ds source:<br>----&gt;".htmlentities($rs_o["arr"][0]["value_text"])."<br>&lt;----<br>" ,"ds");
$object_val_text = $rs_o["arr"][0]["value_text"];
}

//                                     
 if ( $FEATURE['dssource'] ) {
//                   
 $val_text = $construct_val_text;
decho("set ds source with construct ds source.<br>" ,"ds");
if ( $changeable ) {
if ($tagtable == 'objtag' ) {
//                                              
 if ( $object_val_text ) {
$val_text = $object_val_text;
decho("override ds source with object ds source.<br>" ,"ds");
}
} else {
//                                                
 if ( $template_val_text ) {
$val_text = $template_val_text;
decho("override ds source with template ds source.<br>" ,"ds");
}
//                                            
 //                                           
 if ( $page_val_text ) {
$val_text = $page_val_text;
decho("override ds source with page ds source.<br>" ,"ds");
}
}
} else {
//                        
 if ( !$construct_val_text ) {
$val_text = $template_val_text;
decho("override ds source with template ds source because of missing construct ds source.<br>","ds");
}
}
} else {
$val_text = $template_val_text;
decho("Override ds source with template ds source.<br>" ,"ds");
}

decho ("Translating with <br>----&gt;<br>".htmlentities($val_text)."<br>&lt;----<hr>", "ds"); //      
 
$v = $rs["arr"][0];
$is_folder = $v["is_folder"];
$obj = $v["o_type"];
$order = $v["orderkind"];
$sort = $v["orderway"];
$max_obj = $v["max_obj"];
$recursion = $v["recursion"];
if ($obj == $T_PAGE) {
global $SQLAS;
//                             
 $contentgroup_id = 0;
if ($o_type == "content" && $mother_type == "page") {
$contentgroup_id = $_page["contentgroup_id"];
decho ("<br>is_folder==1<br>select: $sql<br>", "ds");

} else if ($mother_type == "page" and $mother_id) {
$tmp = get_pageinfo($mother_id);
$contentgroup_id = $tmp["contentgroup_id"];
}
$sql_cg_where = "";


if ($is_folder == 1 || $is_folder == 3) {
decho ("<br>recursion!=false<br>select: $sql<br>", "ds");

if ($is_folder == 1) {
$sql = "SELECT ds_obj.o_id FROM ds_obj WHERE ds_obj.".sqlf_name($tagtable)."_id = ".sqlf_tl_num($tag_id);
$rs = query($sql);//            
 //                                  
 $sqlor = "folder.id IN (0";
if ($rs["arr"]) while(list($fkey,$fval) = each($rs["arr"])) {
$sqlor .= ",";
$sqlor .= sqlf_tl_num($fval["o_id"]);
if ($recursion) {
$sql = "SELECT id AS o_id FROM folder WHERE mother = ".sqlf_tl_num($fval["o_id"]);
$rstmp = query($sql,true);//            
 if ($rstmp["num"] > 0) {
while (list($key,$val) = each($rstmp["arr"])) {
$rs["arr"][] = $val;
}
}
}
}
$sqlor .= ")";
} else if ($is_folder == 3 && $mother_type == "page") {
$tmp = get_pageinfo($mother_id);
$sqlor = "folder.id = ".((int)$tmp["folder_id"]);
} else {
//                                                                                            
 $sqlor = "folder.id = 0";
}

if ($FEATURE["contentgroup3"] && $contentgroup_id) {
if ( !$FEATURE["dsfallback"] ) {
if ( $FEATURE["ds_empty_cs"] ) $empty_cs = "OR page.contentset_id=0";
else $empty_cs = "";
$sql_cg_where = " AND ( page.contentgroup_id=".sqlf_tl_num($contentgroup_id)." $empty_cs ) ";
}
}


decho ("<br>is_folder==1||is_folder==3 --> select: $sql<br>", "ds");
$directSelection = FALSE;
if ( $sqlor ) $sqlor .= " AND ";
$sql = "SELECT page.contentgroup_id, page.contentset_id, page.content_id, page.id AS page_id, page.template_id, page.folder_id, page.cdate, ".
"page.edate, page.pdate, page.priority, LOWER(page.name) AS l_name ".
"FROM folder, page ".
"LEFT JOIN publish ON (page.id = publish.page_id  AND page.status != 1 AND page.status != 2 AND publish.active = 1) ".
"WHERE $sqlor ".
"((page.status = 1 OR page.status = 2 ) ".
" OR (publish.active IS NOT NULL)) ".
"AND page.folder_id = folder.id $sql_cg_where ";
} else {
if ($FEATURE["nodirectselection"] && $FEATURE["contentgroup3"] ) {
$directselection = FALSE;

$sql = "SELECT page2.contentset_id, page2.contentgroup_id, ds_obj.o_id, page2.content_id, page2.id AS page_id , page2.template_id, ".
"page2.folder_id, page2.cdate, page2.edate, page2.priority, page2.pdate, ds_obj.obj_order, LOWER(page2.name) AS l_name ".
"FROM ds_obj, page ".
"LEFT JOIN page page2 ON (page.contentset_id = page2.contentset_id AND (page.contentset_id > 0 OR page2.id = page.id)) ".
"LEFT JOIN publish ON (page.id = publish.page_id AND page.status != 1 AND page.status != 2 AND publish.active = 1) ".
"WHERE ds_obj.".sqlf_name($tagtable)."_id = ".sqlf_tl_num($tag_id)." ".
"AND page.id = ds_obj.o_id ".
"AND ((page.status = 1 OR page.status = 2) ".
" OR (publish.active IS NOT NULL)) ";

if ($contentgroup_id && !$FEATURE["dsfallback"]) {
if ( $FEATURE["ds_empty_cs"] )
$empty_cs = "OR page2.contentset_id=0";
else
$empty_cs = "";

$sql .= " AND ( page2.contentgroup_id=".sqlf_tl_num($contentgroup_id)." $empty_cs ) ";
}

} else {
$directselection = TRUE;

$sql = "SELECT page.contentset_id, page.contentgroup_id, ds_obj.o_id, page.content_id, page.id AS page_id , page.template_id, ".
"page.folder_id, page.cdate, page.edate, page.priority, page.pdate, ds_obj.obj_order, LOWER(page.name) AS l_name ".
"FROM ds_obj, page ".
"LEFT JOIN publish ON (page.id = publish.page_id AND page.status != 1 AND page.status != 2 AND publish.active = 1) ".
"WHERE ds_obj.".sqlf_name($tagtable)."_id = ".sqlf_tl_num($tag_id)." ".
"AND page.id = ds_obj.o_id ".
"AND ((page.status = 1 OR page.status = 2) ".
" OR (publish.active IS NOT NULL)) ";
}


/*                                                                                                                                           
                                                                                                                                  
                            
                                                                             
                                                                                                                            
                                                  
                                    
                                                    
                                              
*/
decho ("<br>NOT (is_folder==1||is_folder==3) --> select: $sql<br>", "ds");
}

$orderby[1] = "l_name";
$orderby[2] = "page.cdate";
$orderby[3] = "page.edate";
$orderby[7] = "page.priority";
$orderby[5] = "page.filesize";
$orderby[4] = "page.pdate";
$orderby[6] = "obj_order";
$ordersort[1] = " ASC";
$ordersort[2] = " DESC";
if ($orderby[$order]) {
if (!$sort) $sort = 1;
$sql .= " ORDER BY ".$orderby[$order]." ".$ordersort[$sort].", l_name ".$ordersort[$sort];
//                                                
 }
decho( "DS-sql: $sql<br>---------<br>", "ds" );
if ( !$FEATURE["contentgroup3"] || !$FEATURE["dsfallback"] || $directSelection || !$contentgroup_id ) {
$rs = query($sql,false,$max_obj);//            
 } else {
$rs = optimize_datasource_result( query($sql,false), $max_obj, $mother_id, $contentgroup_id, $node_id );//            
 }
$ds_counter = 1;
$ds_rows = $rs["num"];
$ds_content_ids = array();
$ds_content_values = array();
if ($rs["arr"]) while (list($key,$v) = each($rs["arr"])) {
$content_id = $v["content_id"];
$page_id = $v["page_id"];
$folder_id = $v["folder_id"];
$template_id = $v["template_id"];
$ds_content_ids[] = $page_id;

if ($_ottime) {
$_t2 = microtime();
$TS["pt"] += calctime($_t1,$_t2,12);
}
if ($depth == 0) {
global $MAX_DS_RUNTIME;
if ( isset( $MAX_DS_RUNTIME ) )
set_time_limit( $MAX_DS_RUNTIME );
$_tags = translate_pagecontent($page_id,false,$depth+1,$node_id);

if ($DEBUG["dsex"]) {
echo ("\n<br>page_id: ");
var_dump ($page_id);

echo ("\n<br>node_id: ");
var_dump ($node_id);

echo ("\n<br>translate_pagecontent executed: _tags = ");

var_dump ($_tags);
}

} else if ($depth == 1) {
$_page = get_pageinfo($page_id);
$tmp["value"] = $page_id;
$tmp["auto"] = true;
$_tags["seite.id"] = $tmp;
$tmp["value"] = $_page["name"];
$_tags["seite.name"] = $tmp;
$tmp["value"] = $_page["description"];
$_tags["seite.description"] = $tmp;
$_tags["seite.beschreibung"] = $tmp;
$tmp["value"] = make_link("page",$page_id,$node_id,"",$depth);
$_tags["seite.url"] = $tmp;
}
if ($_ottime) $_t1 = microtime();

$_tags[$name.".nr"]["value"] = $ds_counter;
$_tags[$name.".nr"]["auto"] = true;
$_tags["ds.nr"]["value"] = $ds_counter++;
$_tags["ds.nr"]["auto"] = true;
$_tags["ds.count"]["value"] = $ds_rows;
$_tags["ds.count"]["auto"] = true;
$_val = code_translate($val_text,$_tags,"page", false, Array(), $mother_type, $mother_id, false, $node_id);
if ($DEBUG["dsex"]) {
echo ("\n<br>_tags: ");
var_dump ($_tags);

echo ("\n<br>val_text: ");
var_dump ($val_text);

echo ("\n<br>_val: ");
var_dump ($_val);
}

//           
 if ($FEATURE["xnl"]) {
$baseObj = new CNPageObject($page_id);

$props =& $xnlParser->getObjectParser("prop");
$props->setObject("this",$baseObj);
if ($mother_type == "page") {
$container = new CNPageObject($mother_id);
$props->setObject("container",$container);
} else if ($mother_type == "template") {
$container = new CNTemplateObject($mother_id);
$props->setObject("container",$container);
}

$val .= $xnlParser->parse($_val);
$props->unsetObject("this");
$props->unsetObject("container");
} else {
$val .= $_val;
}
$ds_content_values[] = $_val;


}
//             
 $part_prop["count"] = $ds_rows;
$part_prop["$keyword.count"] = $ds_rows;
$part_prop["$keyword.items"] = $ds_content_ids;
$part_prop["$keyword.values"] = $ds_content_values;
} elseif ($FEATURE['dsfile'] && ($obj == $T_FILE || $obj == $T_IMAGE)) {
$ds_content_ids = array();
$ds_content_values = array();
if ($obj == $T_FILE) {
$tagkeyword = 'datei';
$sqlwhere = "LOWER(contentfile.filetype) NOT LIKE 'image%'";
} else {
$tagkeyword = 'bild';
$sqlwhere = "LOWER(contentfile.filetype) LIKE 'image%'";
}
//                     
 if ($is_folder == 1 || $is_folder == 3) {
$sqlor = "";
if ($is_folder == 1) {
$sql = "SELECT ds_obj.o_id FROM ds_obj WHERE ds_obj.".sqlf_name($tagtable)."_id = ".sqlf_tl_num($tag_id);
$rs = query($sql);//            
 $sqlor = "folder.id IN (0";
if ($rs["arr"]) while(list($fkey,$fval) = each($rs["arr"])) {
$sqlor .= ",";
$sqlor .= sqlf_tl_num($fval["o_id"]);
if ($recursion) {
$sql = "SELECT id AS o_id FROM folder WHERE mother = ".sqlf_tl_num($fval["o_id"]);
$rstmp = query($sql,true);//            
 if ($rstmp["num"] > 0) {
while (list($key,$val) = each($rstmp["arr"])) {
$rs["arr"][] = $val;
}
}
}
}
$sqlor .= ") ";
} else if ($is_folder == 3 && $mother_type == "page") {
$tmp = get_pageinfo($mother_id);
$sqlor = "folder.id = ".sqlf_tl_num($tmp["folder_id"])." ";
}
else
{
//                                                                                            
 $sqlor = "folder.id = 0";
}

if ( $sqlor ) $sqlor .= " AND "; 
$sql = "SELECT contentfile.id, contentfile.folder_id, contentfile.name, contentfile.description, contentfile.filesize, 
				contentfile.edate, contentfile.cdate, contentfile.sizex, contentfile.sizey, contentfile.dpix, contentfile.dpiy, LOWER(contentfile.name) AS l_name FROM contentfile, folder 
				WHERE $sqlwhere AND $sqlor folder_id = folder.id";
} else {
$sql = "SELECT contentfile.*, LOWER(contentfile.name) AS l_name FROM ds_obj, contentfile 
			  WHERE $sqlwhere AND contentfile.id = ds_obj.o_id AND ds_obj.".sqlf_name($tagtable)."_id = ".sqlf_tl_num($tag_id);
}

$orderby[1] = "l_name";
$orderby[2] = "contentfile.cdate";
$orderby[3] = "contentfile.edate";
$orderby[7] = ""; //         
 $orderby[5] = "contentfile.filesize";
$orderby[4] = "contentfile.pdate";
$orderby[6] = "obj_order";
$ordersort[1] = " ASC";
$ordersort[2] = " DESC";
if ($orderby[$order]) {
if (!$sort) $sort = 1;
$sql .= " ORDER BY ".$orderby[$order]." ".$ordersort[$sort].", l_name ".$ordersort[$sort];
}
$rs = query($sql,false,$max_obj);//            
 $ds_counter = 1;
$ds_rows = $rs["num"];
node_class("cnfileobject");
if ($rs["arr"]) while (list($key,$v) = each($rs["arr"])) {
$file_id = $v["id"];
$folder_id = $v["folder_id"];
$ds_content_ids[] = $file_id;
if ($_ottime) {
$_t2 = microtime();
$TS["pt"] += calctime($_t1,$_t2,12);
}
$tmp = Array();
$tmp["id"] = $folder_id;
$tmp["type"] = $T_FOLDER;
$_fotags = obj_translate($tmp,"obj",$file_id,"page",$node_id,$edit,$depth+1);
$tmp["id"] = $file_id;
$tmp["type"] = $obj;
$_potags = obj_translate($tmp,"obj",$file_id,"page",$node_id,$edit,$depth+1);
$_val = make_link("file",$file_id,$node_id,"",$depth);
$file = get_fileinfo($file_id);
//                                                                  
 $tmp['value'] = $_val;
$tmp["auto"] = true;
$_tags = Array();
$_tags["$tagkeyword"] = $tmp; 
$fileurl = make_link("file",$file_id,$node_id,"",$depth);
$tmp['value'] = $fileurl;
$_tags["$tagkeyword.url"] = $tmp;
$tmp['value'] = $file_id;
$_tags["$tagkeyword.id"] = $tmp; 
$tmp['value'] = $v["sizex"];
$_tags["$tagkeyword.width"] = $tmp; 
$_tags["$tagkeyword.sizex"] = $tmp; 
$tmp['value'] = $v["sizey"];
$_tags["$tagkeyword.height"] = $tmp; 
$_tags["$tagkeyword.sizey"] = $tmp; 
$tmp['value'] = $v["dpix"];
$_tags["$tagkeyword.dpix"] = $tmp;
$tmp['value'] = $v["dpiy"];
$_tags["$tagkeyword.dpiy"] = $tmp;
$tmp['value'] = $file["name"];
$_tags["$tagkeyword.name"] = $tmp; 
$tmp['value'] = $file["description"];
$_tags["$tagkeyword.description"] = $tmp; 
$tmp['value'] = $file["filesize"];
$_tags["$tagkeyword.sizeb"] = $tmp; 
$tmp['value'] = number_format (ceil($file["filesize"]*10/1024)/10, 1);
$_tags["$tagkeyword.sizeKB"] = $tmp; 
$_tags["$tagkeyword.sizekb"] = $tmp; 
$tmp['value'] = number_format (ceil($file["filesize"]*10/1024/1024)/10, 1);
$_tags["$tagkeyword.sizeMB"] = $tmp; 
$_tags["$tagkeyword.sizemb"] = $tmp; 
$tmp['value'] = $file["folder_id"];
$_tags["$tagkeyword.folder_id"] = $tmp; 
$tmp['value'] = $file["edate"];
$_tags["$tagkeyword.edittimestamp"] = $tmp;
$tmp['value'] = strtolower (eregi_replace (".*\.(.*)$", "\\1", $file["name"]));
$_tags["$tagkeyword.type"]["value"] = $file["filetype"];
$_tags["$tagkeyword.extension"] = $tmp; 
if ($_tags["$tagkeyword.sizeMB"]['value'] > 1) {
$tmp['value'] = $_tags["$tagkeyword.sizeMB"]['value']. ' MB';
} else {
$tmp['value'] = $_tags["$tagkeyword.sizeKB"]['value']. ' KB';
}
$_tags["$tagkeyword.size"] = $tmp; 
$tmp['value'] =  $ds_counter++;
$_tags["$name.nr"] = $tmp; 
$tmp['value'] =  $ds_rows;
$_tags["$name.count"] = $tmp; 

if ($_ottime) $_t1 = microtime();
if ($depth == 0) $_tags = $_potags + $_fotags + $_tags;
$_val = code_translate($val_text,$_tags,"page", $edit, Array(), $mother_type, $mother_id, false, $node_id);

//           
 if ($FEATURE["xnl"]) {
$baseObj = new CNFileObject($file_id);

$props =& $xnlParser->getObjectParser("prop");
$props->setObject("this",$baseObj);
if ($mother_type == "page") {
$container = new CNPageObject($mother_id);
$props->setObject("container",$container);
} else if ($mother_type == "template") {
$container = new CNTemplateObject($mother_id);
$props->setObject("container",$container);
}

$val .= $xnlParser->parse($_val);
$props->unsetObject("this");
$props->unsetObject("container");
} else {
$val .= $_val;
}
$ds_content_values[] = $_val;
}
//             
 $part_prop["count"] = $ds_rows;
$part_prop["$keyword.count"] = $ds_rows;
$part_prop["$keyword.items"] = $ds_content_ids;
$part_prop["$keyword.values"] = $ds_content_values;
//                
 } elseif ($FEATURE['ds_folder'] && $obj == $T_FOLDER) {
$ds_content_ids = array();
$ds_content_values = array();
$tagkeyword = 'ordner';
//                     
 if ($is_folder == 1 || $is_folder == 3 || ($is_folder == 2 && $recursion)) {
if ($is_folder == 1 || ($is_folder == 2 && $recursion)) {
$sql = "SELECT ds_obj.o_id FROM ds_obj WHERE ds_obj.".sqlf_name($tagtable)."_id = ".sqlf_tl_num($tag_id)." AND auser != 0";
$rs = query($sql);//            
 if ($is_folder == 2) { 
$sqlor = "folder.id IN (-1";
} else {				
$sqlor = "folder.mother IN (-1";
}

if ($rs["arr"]) while(list($fkey,$fval) = each($rs["arr"])) {
$sqlor .= ",";
$sqlor .= sqlf_tl_num($fval["o_id"]);
if ($recursion) {
$sql = "SELECT id AS o_id FROM folder WHERE mother = ".sqlf_tl_num($fval["o_id"]);
$rstmp = query($sql,true);//            
 if ($rstmp["num"] > 0) {
while (list($key,$val) = each($rstmp["arr"])) {
$rs["arr"][] = $val;
}
}
}
}
$sqlor .= ")";

} else if ($is_folder == 3 && $mother_type == "page") {

$tmp = get_pageinfo($mother_id);
$sqlor = "folder.mother = ".sqlf_tl_num($tmp["folder_id"]);

}  else if ($is_folder == 3 && $o_type == "template") {
//                                                                      
 //                                                                       
 //                                                                      

$sqlor = " 1 = 2 " ;

} else {

$sqlor = " 1 = 1 ";
}


$sql = "SELECT folder.id, folder.mother, folder.name, folder.description,
          folder.edate, folder.cdate, LOWER(folder.name) AS l_name, folder.pub_dir, folder.node_id FROM folder
          WHERE $sqlor";


} else {
$sql = "SELECT folder.id, folder.mother, folder.name, folder.description,  
          folder.edate, folder.cdate, LOWER(folder.name) AS l_name, folder.pub_dir, folder.node_id FROM folder, ds_obj
          WHERE folder.id = ds_obj.o_id AND ds_obj.".sqlf_name($tagtable)."_id = ".sqlf_tl_num($tag_id)." AND ds_obj.auser != 0";
}

$orderby[1] = "l_name";
$orderby[2] = "folder.cdate";
$orderby[3] = "folder.edate";
$orderby[6] = "obj_order";
$ordersort[1] = " ASC";
$ordersort[2] = " DESC";

if ($orderby[$order]) {
if (!$sort) $sort = 1;
$sql .= " ORDER BY ".$orderby[$order]." ".$ordersort[$sort].", l_name ".$ordersort[$sort];
}

$rs = query($sql,false,$max_obj);//            
 $ds_counter = 1;
$ds_rows = $rs["num"];

node_class("cnfolderobject");
$_temptags = $_tags;
if ($rs["arr"]) while (list($key,$v) = each($rs["arr"])) {
$folder_id = $v["id"];
$mother = $v["mother"];
$ds_content_ids[] = $folder_id;
if ($_ottime) {
$_t2 = microtime();
$TS["pt"] += calctime($_t1,$_t2,12);
}

$tmp = Array();
$tmp["id"] = $folder_id;
$tmp["type"] = $T_FOLDER;
$_fotags = obj_translate($tmp,"obj",$folder_id,"page",$node_id,$edit,$depth+1);

$_tags = $_temptags;
$tmp['value'] = $v["name"];
$tmp["auto"] = true;
$_tags["$tagkeyword"] = $tmp; 
$tmp['value'] = $folder_id;
$_tags["$tagkeyword.id"] = $tmp; 
$tmp['value'] = $v["name"];
$_tags["$tagkeyword.name"] = $tmp; 
$tmp['value'] = $v["description"];
$_tags["$tagkeyword.description"] = $tmp; 
$tmp['value'] = $v["pub_dir"];
$_tags["$tagkeyword.pub_dir"] = $tmp; 
$tmp['value'] = $v["node_id"];
$_tags["$tagkeyword.node_id"] = $tmp; 
$_tags["$tagkeyword.node"] = $tmp; 
$tmp['value'] = $v["mother"];
$_tags["$tagkeyword.mother"] = $tmp; 
$_tags["$tagkeyword.mother_id"] = $tmp; 
$tmp['value'] = $v["edate"];
$_tags["$tagkeyword.edittimestamp"] = $tmp; 
$_tags["ds.count"]["value"] = $ds_rows;
$_tags["ds.nr"]["value"] = $ds_counter;
$tmp['value'] =  $ds_counter++;
$_tags["$name.nr"] = $tmp; 
$tmp['value'] =  $ds_rows;
$_tags["$name.count"] = $tmp; 
if ($_ottime) $_t1 = microtime();
if ($depth == 0) $_tags = $_fotags + $_tags;
$_val = code_translate($val_text,$_tags,"page", $edit, Array(), $mother_type, $mother_id, false, $node_id);
//           
 if ($FEATURE["xnl"]) {
$baseObj = new CNFolderObject($folder_id);

$props =& $xnlParser->getObjectParser("prop");
$props->setObject("this",$baseObj);
if ($mother_type == "page") {
$container = new CNPageObject($mother_id);
$props->setObject("container",$container);
} else if ($mother_type == "template") {
$container = new CNTemplateObject($mother_id);
$props->setObject("container",$container);
}

$_val = $xnlParser->parse($_val);
$props->unsetObject("this");
$props->unsetObject("container");
}
$val .= $_val;
$ds_content_values[] = $_val;
}
//             

$part_prop["count"] = $ds_rows;
$part_prop["$keyword.count"] = $ds_rows;
$part_prop["$keyword.items"] = $ds_content_ids;
$part_prop["$keyword.values"] = $ds_content_values;
//                  
 }
//                                         
 }

$part_prop[$keyword] = $val;
if (!$part_prop["count"]) $part_prop["count"] = 0;

$TAG_VISITED[$t_tag][$tag_id] = false;
}
}

if ($type == 16) $info = 0;
if ($type == 17) $info = 1;

//     
 if ($type == 15 || $type == 16 || $type == 17) {
if ($info == 0) $l = "ul";
else $l = "ol";
if ( $info_text ) $__class = " class=\"$info_text\"";
else $__class = "";
$val = "<$l$__class>\n";
$val_text = str_replace("\r","",$val_text);
$lines = explode("\n",$val_text);
if (is_array($lines)) {
$firstnl = true;
$_i = 0;
while (list($k,$v) = each($lines)) {
if ($v) {
$i++;
$val .= "<li>$v</li>\n";
$firstnl = true;
} else {
if ($firstnl) {
$val .= "<br><br>\n";
$firstnl = false;
} else $val .= "<br>\n";
}
}
}
$val .= "</$l>\n";
$part_prop[$keyword] = $val;
$part_prop[$keyword."count"] = $i;
}

//              
 if ($type == 18 || $type == 19 || $type == 24) {
$val .= $val_text;
$part_prop[$keyword] = $val;
}

//                               
 if ( $type == 29 || $type == 30 )
{
if ( strlen($val_text) > 0 )
{
$sourceList = explode( "|-|", $val_text );
node_class( "sourcefactory" );
$source =& SourceFactory::loadSingle( $info_int );
if ( $source ) {
$translated = $source->translate( $sourceList, $info_text );
$val .= $translated["value"];
$part_prop[$keyword] = $val;
$list = $source->export();
$tmp = array();
foreach ( $sourceList as $sourceKey )
{
$tmp[] = $list[$sourceKey]["value"];
}
$part_prop[$keyword.".items"] = $tmp;
if ( is_array( $translated["props"] ) ) {
foreach ( $translated["props"] as $key=>$_prop )
{
$part_prop[$keyword.".".$key] = $_prop;
}
}
}
}
}

//        
 if ( $type == 31 )
{
if ( $val_text )
$part_prop[$keyword] = 1;
else
$part_prop[$keyword] = 0;
$val = $part_prop[$keyword];
}

//          
 if ( $type == 32 )
{
if ( !$FEATURE["datasource_translate"] ) {
$val .= "<nodedatasource $val_ref>$info_text</nodedatasource>";
$part_prop[$keyword] = $val;
} else {
$dsId = $val_ref;
$dsTemplate = $info_text; 
unset( $source );
$source =& SourceFactory::loadSingle( $dsId );
if ( $source )
{
$tr = $source->translate( $source->exportIds(), $dsTemplate );
$val .= $tr['value'];
$list = $source->export();
$tmp = array();
foreach ( $source->exportIds() as $sourceKey )
{
$tmp[] = $list[$sourceKey]["value"];
}
$part_prop[$keyword.".items"] = $tmp;
if ( is_array( $tr["props"] ) ) {
foreach ( $tr["props"] as $key=>$_prop )
{
$part_prop[$keyword.".".$key] = $_prop;
}
}
}
$part_prop[$keyword] = $val;
}
}

$ret["part_prop"] = $part_prop;
$ret["val"] = $val;

if ($_ottime) {
$_t2 = microtime();
$TS["pt"] += calctime($_t1,$_t2,12);
}

if ( $FEATURE["xnl"] )
{
//       
 $xnlParser->setErrorPrefix( $xnlErrorPrefix );
}

/*                                    
                                                         
  */
return $ret;

}

?>
