<?
GUIFactory::setMainGUI("main");
load_menu(822,$T_ERROR,0);
node_class("itemlist3");
node_class("sqldatasource");
node_class("dateformatter");

$LOGERROR_DESC[101] = i18n("internal_event");
$LOGERROR_DESC[7] = i18n("internal_event");
$LOGERROR_DESC[106] = i18n("database");
$LOGERROR_DESC[105] = i18n("filesystem");
$LOGERROR_DESC[104] = i18n("warning");

//     #                                 
$LOGERROR_DESC[110] = i18n("jserror");

$LOGERROR_PUBLIC[106] = true;
$LOGERROR_PUBLIC[105] = true;
$LOGERROR_PUBLIC[104] = true;

//     #                                 
$LOGERROR_PUBLIC[110] = true;

//                                                              
$LOGERROR_PUBLIC[120] = true;

//                                                                
$LOGERROR_PUBLIC[10003] = true;

mysession_var_reg("ERRORLOG_RANGE");
if ($range) $ERRORLOG_RANGE = ($range=="all")?"":$range;

class ErrorDetailFormatter extends ResultsetFormatter 
{
function format($val, $param="")
{
global $LOGERROR_DESC, $LOGERROR_PUBLIC, $USER_ID;

if ($LOGERROR_DESC[$val["halt_id"]]) $myerror = $LOGERROR_DESC[$val["halt_id"]];
else $myerror = $LOGERROR_DESC[101];

if ($USER_ID == 1 || $LOGERROR_PUBLIC[$val["halt_id"]]) {
if (!$LOGERROR_PUBLIC[$val["halt_id"]]) $myerror = "<i>$myerror </i> ";
$val["detail"] = $myerror." - ".$val["detail"];
return $val["detail"];
} else 
return $LOGERROR_DESC[101];
}
}

if ($cmd == "del" && perm($USER_ID, $T_ERROR,0,8)) {
$sql = "DELETE FROM logerror WHERE timestamp < (".sqlf_tl_num($TIME)." - 604800)";
if ($ERRORLOG_RANGE) {
$sql .= " AND errordo >= ".sqlf_tl_num($MODULES_DORANGE[$ERRORLOG_RANGE][0])." AND errordo < ".sqlf_tl_num($MODULES_DORANGE[$ERRORLOG_RANGE][1]);
}
query($sql);//            
}



//                        
$select = "logerror.id as id, logerror.sid as sid, logerror.user_id as user_id, concat( systemuser.firstname, ' ', systemuser.lastname ) as name, ".
"logerror.halt_id as halt_id, logerror.request as request, logerror.errordo AS do, ".
"logerror.timestamp as timestamp, logerror.detail as detail";
$from   = "logerror LEFT JOIN systemuser ON (logerror.user_id = systemuser.id)";

$where = '';
if ($ERRORLOG_RANGE) {
$where = "logerror.errordo >= ".sqlf_tl_num($MODULES_DORANGE[$ERRORLOG_RANGE][0])." AND logerror.errordo < ".sqlf_tl_num($MODULES_DORANGE[$ERRORLOG_RANGE][1]);
}

$ds = new SQLDatasource( "error", $select, $from, $where );//            
$ds->setDBHandle( $DB );
$ds->addColumn( "halt_id", i18n("Halt-ID"), true, false );
$ds->addColumn( "ftimestamp", i18n("date"), true, false, "logerror.timestamp" );
$ds->addColumn( "do", i18n("Node-DO"), true, "logerror.errordo" );
$ds->addColumn( "fdetail", i18n("Details"), true, false );
$ds->setWrappable("fdetail", true);
$ds->addFormatter("ftimestamp", new DateFormatter("timestamp"));
$ds->addFormatter("fdetail", new ErrorDetailFormatter());
$ds->addSearchableColumn("systemuser.firstname");
$ds->setDefaultSort("ftimestamp","DESC");

//           
$list = new ItemList3("logerror",$ds);
$list->setShowInfo( true );



?>
