<?
GUIFactory::setMainGUI( "main" );
$maingui = &GUIFactory::getGUI("main");

load_menu( 301, T_OBJPROP_MAINTENANCE );

class TypeNameFormatter extends ResultsetFormatter {
function NameFormatter( ) {
}
function format( $row ) {
global $T_TYPE;
return $T_TYPE[$row["type"]]["name"];
}
}

class ObjectNameFormatter extends ResultsetFormatter {
function NameFormatter( ) {
}
function format( $row ) {
global $T_TYPE;
return $T_TYPE[$row["object"]]["name"];
}
}

function runTests( &$form, $param ) {
$emptyObjTagsCount = &$form->resolveComponent("emptyobjtagscount");
$emptyObjTagsList = &$form->resolveComponent("emptyobjtagslist");
$info =& testEmptyObjTags(false);

$emptyObjTagsCount->setText($info["totalcount"]);
$ds = &$emptyObjTagsList->getDatasource();
$ds->setItems($info["detail"]);

$cleanbutton = &$form->getButton("cleanall");
$cleanbutton->setEnabled($info["totalcount"] > 0);
}

function cleanAll(&$form, $param) {
testEmptyObjTags(true);
runTests(&$form, $param);
}

$runtest = false;

function delete( $id ) {
global $runtest;
if (strpos($id, "|inpage") !== false) {
$id = substr($id, 0, strpos($id, "|inpage"));
testInpageEmptyObjTags($id, true);
} else {
testSingleEmptyObjTags($id, true);
}
$runtest = true;
}

function &testInpageEmptyObjTags($objprop, $clean = false) {
global $T_PAGE;
$info = getObjPropInfo($objprop);

//                                                                                                                                           
 if ($info["type"] == 10002 || $info["type"] == 10006) {
$sql = "select count(distinct(objtag.id)) c from objtag left join page on objtag.obj_id = page.id ".
"left join objtag template_oe on template_oe.obj_id = page.template_id and template_oe.name = objtag.name and template_oe.inpage = 1 ".
"left join objtag folder_oe on folder_oe.obj_id = page.folder_id and folder_oe.name = objtag.name and folder_oe.inpage = 1 ".
"where objtag.name = '".sqlf_escaped($info["keyword"])."' and objtag.obj_type = 10007 and objtag.obj_id != 0 and objtag.enabled = 0 and objtag.inpage = 1 and template_oe.id is null and folder_oe.id is null";
$rs = query($sql);//            
 $count = $rs["arr"][0]["c"];
if ($count > 0 && $clean) {
$sql = "select distinct(objtag.id) from objtag left join page on objtag.obj_id = page.id ".
"left join objtag template_oe on template_oe.obj_id = page.template_id and template_oe.name = objtag.name and template_oe.inpage = 1 ".
"left join objtag folder_oe on folder_oe.obj_id = page.folder_id and folder_oe.name = objtag.name and folder_oe.inpage = 1 ".
"where objtag.name = '".sqlf_escaped($info["keyword"])."' and objtag.obj_type = 10007 and objtag.obj_id != 0 and objtag.enabled = 0 and objtag.inpage = 1 and template_oe.id is null and folder_oe.id is null limit 1000";
while(true) {
$rs = query($sql);//            
 if ($rs["num"] > 0) {
$toclean = array();
while (list($k, $row) = each($rs["arr"])) {
$toclean[] = $row["id"];
}
query("delete from objtag where id in (".implode(",",sqlf_tl_num_array($toclean)).")");//            
 } else {
break;
}
}
}
}

if ($count > 0) {
if (!$clean) {
return array("id" => "$objprop|inpage", "type" => $info["type"], "object" => $T_PAGE, "name" => $info["name"], "keyword" => $info["keyword"], "count" => $count);
}
} else {
return false;
}
}

function &testSingleEmptyObjTags($objprop, $clean = false) {
$info = getObjPropInfo($objprop);
$nodes = getNodesForObjectProperty($objprop);
if (!$nodes) {
return false;
}

switch($info["type"]) {
case 10002:
$join = "left join folder on objtag.obj_id = folder.id";
break;
case 10007:
$join = "left join page on objtag.obj_id = page.id left join folder on page.folder_id = folder.id";
break;
case 10006:
$join = "left join template on objtag.obj_id = template.id left join template_folder on template.id = template_folder.template_id left join folder on template_folder.folder_id = folder.id";
break;
case 10008:
case 10011:
$join = "left join contentfile on objtag.obj_id = contentfile.id left join folder on contentfile.folder_id = folder.id";
break;
default:
continue;
}

$sql = "select count(distinct(objtag.id)) c from objtag $join left join value on objtag.id = value.objtag_id where objtag.obj_type = ".sqlf_tl_num($info["type"])." and objtag.name ='".sqlf_escaped($info["keyword"])."' and enabled = 0 and folder.node_id not in (".implode(",",sqlf_tl_num_array($nodes)).") and value.id is null and objtag.id != 0";
$rs = query($sql);//            
 $count = $rs["arr"][0]["c"];
if ($count > 0) {
if ($clean) {
$sql = "select distinct objtag.id from objtag $join left join value on objtag.id = value.objtag_id where objtag.obj_type = ".sqlf_tl_num($info["type"])." and objtag.name ='".sqlf_escaped($info["keyword"])."' and enabled = 0 and folder.node_id not in (".implode(",",sqlf_tl_num_array($nodes)).") and value.id is null and objtag.id != 0 limit 1000";
while(true) {
$rs = query($sql);//            
 if ($rs["num"] > 0) {
$toclean = array();
while (list($k, $row) = each($rs["arr"])) {
$toclean[] = $row["id"];
}
query("delete from objtag where id in (".implode(",",sqlf_tl_num_array($toclean)).")");//            
 } else {
break;
}
}
}
}

if ($count > 0) {
if (!$clean) {
return array("id" => $objprop, "type" => $info["type"], "object" => $info["type"], "name" => $info["name"], "keyword" => $info["keyword"], "count" => $count);
}
} else {
return false;
}
}

function &testEmptyObjTags($clean = false) {
//                                                      
 $types = array(10002, 10006, 10007, 10008, 10011);

$totalCount = 0;
$objTagInfo = array();

reset($types);
while( list($k1, $type) = each($types)) {
$objprops = getObjPropsForType($type);
reset($objprops);
while( list($k2, $objprop) = each($objprops)) {
$info =& testSingleEmptyObjTags($objprop, $clean);
if (is_array($info)) {
$totalCount += $info["count"];
$objTagInfo[$objprop] = $info;
}

if ($type == 10002 || $type == 10006) {
$info =& testInpageEmptyObjTags($objprop, $clean);
if (is_array($info)) {
$totalCount += $info["count"];
$objTagInfo[$objprop."|inpage"] = $info;
}
}
}
}

if ($clean) {
return true;
} else {
return array("totalcount" => $totalCount, "detail" => $objTagInfo);
}
}

/*
 *                                                                                                                           
 *                                                         
 *                                                                            
 */
function getNodesForObjectProperty($objprop_id) {
if (!$objprop_id) {
return false;
}
$sql = "SELECT node_id FROM objprop_node WHERE objprop_id = ".sqlf_tl_num($objprop_id);
$rs = query($sql);//            
 if ($rs["num"] == 0) {
return false;
}

$node_ids = array();
while (list($key,$val) = each($rs["arr"])) {
$node_ids[] = $val["node_id"];
}
return $node_ids;
}

/*
 *                                              
 *                     
 *                                      
 */
function getObjPropsForType($type) {
if (!$type) {
return null;
}
$sql = "SELECT objprop.id FROM objprop LEFT JOIN objtag ON objprop.objtag_id = objtag.id WHERE objtag.obj_type = ".sqlf_tl_num($type);
$rs = query($sql);//            
 $objprop_ids = array();
while (list($key, $val) = each($rs["arr"])) {
$objprop_ids[] = $val["id"];
}

return $objprop_ids;
}

/*
 *                                                         
 *                                    
 *                                                     
 */
function getObjPropInfo($id) {
global $LANGUAGE;
$sql = "select objtag.name keyword, dicuser.value name, objtag.obj_type type from objprop left join objtag on objprop.objtag_id = objtag.id left join dicuser on dicuser.output_id = objprop.name_id WHERE objprop.id = ".sqlf_tl_num($id)." and dicuser.language_id = ".sqlf_tl_num($LANGUAGE)." limit 1";
$rs = query($sql);//            
 return $rs["arr"][0];
}

$form = new HtmlForm3("objprop_maintenance");
if ($form->isNew()) {
$form->setHeader(i18n("Object Property Maintenance"), $ICO_OBJPROP);

$form->addComponent("description", new LabelComponent(null, i18n("Object Property Maintenance Description"), true));

$emptyObjTags = new LabelComponent(i18n("Unfilled Object Tags"), i18n("- Not Tested -"), true);
$form->addComponent("emptyobjtagscount", $emptyObjTags);

$cols = array("type" => i18n("type"), "object" => i18n("object"), "name" => i18n("name"), "keyword" => $DIC["760"], "count" => i18n("count"));

$ds = new ArrayDatasource(array(), $cols);
$ds->setSort("type");
$ds->addFormatter( "type", new TypeNameFormatter( ) );
$ds->addFormatter( "object", new ObjectNameFormatter( ) );
$ds->addAction(new CommandAction($ICO_DELETE, 'delete', i18n('delete'), 'delete'));

$itemlist = new ItemList3("itemlist", $ds);
$itemlist->setGroupableColumns(array("type"));
$itemlist->setNextSortWay("type");

$list = new ItemListComponent(NULL, $itemlist);
$form->addComponent("emptyobjtagslist", $list);

$form->addButton("runtest", new Button(i18n("Run Tests")), new SimpleFormAction("runTests"), true);
$form->addButton("cleanall", new Button(i18n("Clean all"), true, false), new SimpleFormAction("cleanAll"), false);
} else if ($runtest) {
runTests( &$form, null ); 
}

?>
