<?php

/**
 *                             
 *                                      
 *                                                              
 *                                                                             
 *                                                     
 */
function load_related( $r, $viewsTitle=false, $activeView=false )
{
global $CONTENTGROUP_ID;

if ( !is_array( $r ) )
return;

global $JS, $DIC, $USER_ID;
$html = "";
$title = $DIC[281];
$count = 0;

foreach ( $r as $rel ) {
if(! is_array($rel) ) continue;
$allowed = true;
$perms = $rel["perms"];
if ( is_array( $perms ) )
{
if( $perms['role_bit'] ) {
$allowed = perm( $USER_ID, $perms["t_type"], $perms["o_id"], $perms["bit"], $CONTENTGROUP_ID, $perms["role_type"], $perms['role_bit'] );
} else {
$allowed = perm( $USER_ID, $perms["t_type"], $perms["o_id"], $perms["bit"] );
}
}

if ( $allowed )	{

$count ++;
$icon = $rel["icon"];
$link = addslashes($rel["link"]);
$text = $rel["text"];
$alttext = $text;
$help = $rel["help"];
$target = $rel["target"];
$ttype = $rel['ttype'];
$imgclass = '';
if( $ttype && is_array( $perms ) ) {
$obj = &NodeFactory::getStaticInstanceOf( $ttype );
//                                                                           
 $res = $obj->searchInObject($perms['t_type'], $perms['o_id'], null, false, false, true);
if(count($res) < 1) {
$imgclass = 'gentics_icon_invisible';
}
$alttext .= ' ' . i18n( '({0} Items)', 0, count($res));
}

if ($viewsTitle) {
if ($text == $activeView["text"]) {
$class = ' class="active"';
//               
 } else {
$class = "";
}
$html .= "views += '<a href=\"$link\" target=\"$target\"$class>" . img($icon, 0, $alttext, '', '', '', '', '', $imgclass) . "</a>';\n";
} else {
$html .= "related += '<span ' +";
if ( in_array( $target, array( "list", "tree", "menu" ) ) ) {
$onclick = "onclick=\"progress(top.menu); return true;\"";
} else { 
$onclick = "";
}
$html .= "'><a target=\"$target\" href=\"$link\" $onclick>".img($icon, 0)." $text</a></span>';\n";
}
}
}

if ( $count > 0 ) {
if ($viewsTitle) {
$JS .= "
				var views = '';
				var viewsName = '$viewsTitle';
				$html;

				";
} else {
$JS .= "
				var related='';
				$html
				related += '';
				
				if ( parent.ass && parent.ass.ass_reset)
				{
					parent.ass.ass_reset();
					parent.ass.info();
				}";
}
}
}
?>