<?

class SyncUser {

var $entry;
var $user_id;
var $login;
var $groups;
var $fields;

function SyncUser() {
$this->entry = false;
$this->user_id = false;
$this->login = false;
$this->groups = array();
$this->fields = array();
}

function getUserFromDB($uid = 0) {
if (!$this->user_id && !$uid) return false;

if (!$uid) $uid = $this->user_id;

$sql = "SELECT firstname, lastname, login, email, isldapuser FROM systemuser WHERE id = ".sqlf_tl_num($uid)." AND active > 0";
$rs = query($sql);//            
 $r = $rs["arr"][0];
if ($rs["num"] == 0) return false;

$this->entry = array();
$this->groups = array();
$this->user_id = $uid;
$this->login = $r["login"];

$this->entry["firstname"] = $r["firstname"];
$this->entry["lastname"] = $r["lastname"];
$this->entry["login"] = $r["login"];
$this->entry["email"] = $r["email"];

///                               
 $sql = "SELECT usergroup_id FROM user_group WHERE user_id = ".sqlf_tl_num($uid);
$rs = query($sql);//            
 while (list($key,$val) = each($rs["arr"])) {
$this->groups[] = $val["usergroup_id"];
}

$this->entry["group"] = $this->groups;

return $this->user_id;
}

//                                                                                                                                 
 //                                                /           /  
 function syncToDB($uid=0, $forceDel = true) {
global $USER_ID, $TIME;

if (!$this->canSync()) return false;

if ($uid == -1) {
if (!is_false($this->user_id)) $uid = $this->user_id;
else $uid = 0;
}
if (!$uid) {
if (!is_false($this->user_id)) $uid = $this->user_id;
else $uid = 0;
}
//                                                                
 $this->user_id = false;

//                                                           
 if (is_false($this->entry) || !is_array($this->groups) || (count($this->groups) == 0 && $forceDel)) {
if ($uid > 0) {
$sql = "UPDATE systemuser SET active = 0, isldapuser = 1 WHERE id = ".sqlf_tl_num($uid);
query($sql);//            
 $sql = "DELETE FROM user_group WHERE user_id = ".sqlf_tl_num($uid);
query($sql);//            
 }

return $uid;
}

//                 
 $entry = $this->entry;
if ($uid == 0) {
$sql = "INSERT INTO systemuser (firstname,lastname,login,email,active,isldapuser,creator,editor,cdate,edate) VALUES 
					(\"".sqlslashes($entry["firstname"][0])."\",\"".sqlslashes($entry["lastname"][0])."\",
					 \"".sqlslashes($entry["login"][0])."\",\"".sqlslashes($entry["email"][0])."\",
					 1,1,".sqlf_tl_num($USER_ID).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",".sqlf_tl_num($TIME).")";
$rs = query($sql);//            
 $uid = $rs["iid"];

if ($entry["pw"][0]) {
$sql = "UPDATE systemuser SET password = \"".sqlslashes(crypt_pw($uid,$entry["pw"][0]))."\" WHERE id = ".sqlf_tl_num($uid);
query($sql);//            
 }
$new = true;
} else {
if ($entry["pw"][0]) $passwd = "password = \"".sqlslashes(crypt_pw($uid,$entry["pw"][0]))."\", ";
$sql = "UPDATE systemuser SET firstname = \"".sqlslashes($entry["firstname"][0])."\", 
										  lastname = \"".sqlslashes($entry["lastname"][0])."\", 
										  login = \"".sqlslashes($entry["login"][0])."\", 
										  email = \"".sqlslashes($entry["email"][0])."\", 
										  $passwd
						active = 1, isldapuser = 1, edate = ".sqlf_tl_num($TIME).", editor = ".sqlf_tl_num($USER_ID)." WHERE id = ".sqlf_tl_num($uid);
query($sql);//            
 $new = false;
}

//              
 $sqlpart = "";
reset($this->groups);
while (list($key,$gid) = each($this->groups)) {

if ($gid == 1) $foundg1 = true;
if ($gid == 2) $foundg2 = true;

///                                                                                                         
 $sql = "SELECT usergroup_id FROM user_group WHERE user_id = ".sqlf_tl_num($uid)." AND usergroup_id = ".sqlf_tl_num($gid);
$rs = query($sql);//            
 if ($rs["num"] == 0) {

//                                    
 if ($gid != 1 && $gid != 2) { 
$sql = "INSERT INTO user_group (user_id, usergroup_id, creator, cdate) VALUES (".sqlf_tl_num($uid).", ".sqlf_tl_num($gid).", ".sqlf_tl_num($USER_ID).", ".sqlf_tl_num($TIME).")";
query($sql);//            
 }
}
if ($sqlpart) $sqlpart .= ",";
$sqlpart .= sqlf_tl_num($gid);
}

//                           
 if (!$foundg1) {
$sql = "DELETE FROM user_group WHERE user_id = ".sqlf_tl_num($uid)." AND usergroup_id = 1";
query($sql);//            
 }
if (!$foundg2) {
$sql = "DELETE FROM user_group WHERE user_id = ".sqlf_tl_num($uid)." AND usergroup_id = 2";
query($sql);//            
 }

if (!$new && $sqlpart) {
$sql = "DELETE FROM user_group WHERE user_id = ".sqlf_tl_num($uid)." AND usergroup_id NOT IN ($sqlpart)";
query($sql);//            
 }

$this->user_id = $uid;
return $uid;
}

//                                                                             /     
 function getGroups() {
return $this->groups;
}

function getUserID() {
return $this->user_id;
}

function getLogin() {
return $this->login;
}

function getFields() {
return $this->fields;
}

function getDefGroups() {}

function canSync() {}
}

class LDAPSync extends SyncUser {

var $ldb;
var $pw = false;

/**
  *                                        
  **/
function LDAPSync() {
global $LDAP_LOGIN, $LDAP_LOGIN_FIELDS;
parent::SyncUser();

if ($LDAP_LOGIN["login"]) $this->ldb = mydb_connect("",$LDAP_LOGIN["server"],$LDAP_LOGIN["login"],$LDAP_LOGIN["pw"],"ldap");

$this->fields = $LDAP_LOGIN_FIELDS;
}

function __wakeup() {
if ($this->ldb) mydb_reconnect($this->ldb);
}

/**
  *               
  *                                                                             
  **/
function getDefGroups() {
$res = array();

if (is_array($this->entry["group"])) {
$res = $this->entry["group"];
} else if (is_numeric($this->fields["group"])) {
$res = array($this->fields["group"]);
} else if (is_array($this->fields["group"])) {
$res = $this->fields["group"];
}

return $res;
}

/**
  *                                                         
  *
  *                                                            
  *                         
  *                                         
  **/
function getUserFromLogin($login, $pw = false) {
global $LDAP_LOGIN;

if ($LDAP_LOGIN["auto"] && !is_false($pw)) {
$this->ldb = mydb_connect("",$LDAP_LOGIN["server"], $login, $pw, "ldap");
}
$this->pw = $pw;

if (!$this->ldb) return false;

///                           
 $login = str_replace(",","",$login);

if ($LDAP_LOGIN["filter"]) {
$filter = "(&(" . $LDAP_LOGIN["filter"] . ")(".$this->fields["login"]."=".$login . "))";
} else {
$filter = "(".$this->fields["login"]."=".$login . ")";
}

if (!$LDAP_LOGIN["basedn"]) halt(7,"getUserFromLogin: no basedn(".$LDAP_LOGIN["basedn"].")");

$basedn = "";
if ($LDAP_LOGIN["searchdn"]) $basedn = $LDAP_LOGIN["searchdn"].",";
$basedn .= $LDAP_LOGIN["basedn"];

$this->login = $login;

return $this->_loadEntry($basedn, $filter);
}

function getUserFromDN($dn) {
global $LDAP_LOGIN;

if (!$this->ldb) return false;

if ($LDAP_LOGIN["filter"]) {
$filter = "(".$LDAP_LOGIN["filter"].")";
} else {
$filter = "objectClass=*";
}
$basedn = $dn;

$this->login = false;

return $this->_loadEntry($basedn, $filter);
}

function _loadEntry($basedn, $filter) {

if (is_array($this->fields)) {
$fields = $this->fields;
reset($fields);
$attr = array();
while (list($key,$val) = each($fields)) {
if ($key != "splitter") $attr[] = $val;
}
} else halt(7,"LDAPUser::_loadEntry: no fields defined or not an array fields($this->fields)");

$rs = query(array("cmd"=>"select","basedn"=>$basedn, "filter"=>$filter,"attr"=>$attr,"type"=>"base"), $this->ldb);//         

//                      
 if ($rs["num"] == 0) {
$this->entry = false;
$this->user_id = false;
$this->groups = $this->getDefGroups();
return false;
}

//                                      
 if ($rs["num"] > 0) {
$this->entry = false;
$this->user_id = false;
$this->groups = false;
warning(20, "LDAPUser::_loadEntry: got more than one user for login ($basedn) ($filter).");
return false;
}

$this->entry = array();

//                     
 reset($fields);
while (list($key,$val) = each($fields)) {
//                              
 if (strtolower($key) == "pw" && !is_false($this->pw)) $this->entry[strtolower($key)] = $this->pw;
else if ($key != "splitter") $this->entry[strtolower($key)] = $rs["arr"][0][$val];
}

//                                              
 $this->groups = $this->getDefGroups();

$this->login = $this->entry["login"];
if (!$this->login) {
halt(7, "LDAPUser::_loadEntry: found LDAP entry with no login or login field not configured.");
}

//                                  
 $sql = "SELECT id, isldapuser FROM systemuser WHERE login = \"".sqlslashes($this->login)."\" AND active > 0";
$rs = query($sql,1);//            

if ($rs["num"] == 1) {
$this->user_id = $rs["arr"][0]["id"];
} else if ($rs["num"] == 0) {
$this->user_id = false;
} else {
halt(7, "LDAPUser::_loadEntry: found more than one systemuser entry for login (".$this->login.")");
}

return true;
}

function canSync() {
return true;
}

function syncToLDAP() {

}

}

class HTTPSync extends SyncUser {

function HTTPSync($config = false) {
global $HTTP_AUTH_LOGIN;
parent::SyncUser();
if (is_array($config)) {
$this->fields = $config;
} else {
$this->fields = $HTTP_AUTH_LOGIN;
}

}

function getDefGroups() {
$res = array();

$_group = $this->fields["group"];
if (is_numeric($_group)) {
$res = array((int) $_group);
} else if (is_array($_group)) {
$res = $_group;
} else {
$group = $this->entry["group"];
if (is_array($group)) {
$res = $group;
} else if ($this->fields["splitter"]) {
$res = explode($this->fields["splitter"],$group);
} else {
$res = array((int) $group);
}
}
return $res;
}

function getUserFromURL() {
return $this->_loadEntry(false, array());
}

function getUserFromParams($params) {
return $this->_loadEntry(true, $params);
}

function _fetchEntry($field, $useparams, $params, $def = false) {
if ($_field = $this->fields[$field]) {
if (!$useparams) {
global $$_field;
return $$_field;
} else {
return $params[$field];
}
} else if (is_array($def)) {
return $def[$field];
} else {
return false;
}
}

function _loadEntry($useparams, $params) {

$login = $this->_fetchEntry("login", $useparams, $params);
if (!$login) return false;

$this->entry = array();
$this->user_id = false;
$this->groups = array();
$this->login = $login;

$this->entry["login"][0] = $login;

$sql = "SELECT id, firstname, lastname, email, password FROM systemuser WHERE login = \"".sqlslashes($login)."\" AND active > 0";
$rs = query($sql);//            
 if ($rs["num"] == 0) {
$r = array();
} else {
$r = $rs["arr"][0];
$this->user_id = $r["id"];
}

$this->entry["pw"][0] = $this->_fetchEntry("pw",$useparams, $params, false);

$this->entry["firstname"][0] = $this->_fetchEntry("firstname", $useparams, $params, $r);

$this->entry["lastname"][0] = $this->_fetchEntry("lastname", $useparams, $params, $r);

$this->entry["email"][0] = $this->_fetchEntry("email", $useparams, $params, $r);

$this->entry["group"] = $this->_fetchEntry("group", $useparams, $params);

if (is_false($this->entry["group"])) {
$this->entry["group"] = array();
if ($this->user_id) {
$sql = "SELECT usergroup_id FROM user_group WHERE user_id = ".sqlf_tl_num($this->user_id);
$rs = query($sql,1);//            
 while (list($key,$val) = each($rs["arr"])) {
$this->entry["group"][] = $val["usergroup_id"];
}
}
}

$this->groups = $this->getDefGroups();

return true;
}

function canSync() {
return ($this->fields["login"]?true:false);
}

function usePassword() {
if ($this->fields["login"] && !$this->fields["pw"]) {
return false;
} else {
return true;
}
}
}

?>
